
;CodeVisionAVR C Compiler V3.12 Advanced
;(C) Copyright 1998-2014 Pavel Haiduc, HP InfoTech s.r.l.
;http://www.hpinfotech.com

;Build configuration    : Debug
;Chip type              : ATmega8
;Program type           : Application
;Clock frequency        : 4,000000 MHz
;Memory model           : Small
;Optimize for           : Size
;(s)printf features     : int, width
;(s)scanf features      : int, width
;External RAM size      : 0
;Data Stack size        : 256 byte(s)
;Heap size              : 0 byte(s)
;Promote 'char' to 'int': Yes
;'char' is unsigned     : Yes
;8 bit enums            : Yes
;Global 'const' stored in FLASH: Yes
;Enhanced function parameter passing: Yes
;Enhanced core instructions: On
;Automatic register allocation for global variables: On
;Smart register allocation: On

	#define _MODEL_SMALL_

	#pragma AVRPART ADMIN PART_NAME ATmega8
	#pragma AVRPART MEMORY PROG_FLASH 8192
	#pragma AVRPART MEMORY EEPROM 512
	#pragma AVRPART MEMORY INT_SRAM SIZE 1024
	#pragma AVRPART MEMORY INT_SRAM START_ADDR 0x60

	.LISTMAC
	.EQU UDRE=0x5
	.EQU RXC=0x7
	.EQU USR=0xB
	.EQU UDR=0xC
	.EQU SPSR=0xE
	.EQU SPDR=0xF
	.EQU EERE=0x0
	.EQU EEWE=0x1
	.EQU EEMWE=0x2
	.EQU EECR=0x1C
	.EQU EEDR=0x1D
	.EQU EEARL=0x1E
	.EQU EEARH=0x1F
	.EQU WDTCR=0x21
	.EQU MCUCR=0x35
	.EQU GICR=0x3B
	.EQU SPL=0x3D
	.EQU SPH=0x3E
	.EQU SREG=0x3F

	.DEF R0X0=R0
	.DEF R0X1=R1
	.DEF R0X2=R2
	.DEF R0X3=R3
	.DEF R0X4=R4
	.DEF R0X5=R5
	.DEF R0X6=R6
	.DEF R0X7=R7
	.DEF R0X8=R8
	.DEF R0X9=R9
	.DEF R0XA=R10
	.DEF R0XB=R11
	.DEF R0XC=R12
	.DEF R0XD=R13
	.DEF R0XE=R14
	.DEF R0XF=R15
	.DEF R0X10=R16
	.DEF R0X11=R17
	.DEF R0X12=R18
	.DEF R0X13=R19
	.DEF R0X14=R20
	.DEF R0X15=R21
	.DEF R0X16=R22
	.DEF R0X17=R23
	.DEF R0X18=R24
	.DEF R0X19=R25
	.DEF R0X1A=R26
	.DEF R0X1B=R27
	.DEF R0X1C=R28
	.DEF R0X1D=R29
	.DEF R0X1E=R30
	.DEF R0X1F=R31

	.EQU __SRAM_START=0x0060
	.EQU __SRAM_END=0x045F
	.EQU __DSTACK_SIZE=0x0100
	.EQU __HEAP_SIZE=0x0000
	.EQU __CLEAR_SRAM_SIZE=__SRAM_END-__SRAM_START+1

	.MACRO __CPD1N
	CPI  R30,LOW(@0)
	LDI  R26,HIGH(@0)
	CPC  R31,R26
	LDI  R26,BYTE3(@0)
	CPC  R22,R26
	LDI  R26,BYTE4(@0)
	CPC  R23,R26
	.ENDM

	.MACRO __CPD2N
	CPI  R26,LOW(@0)
	LDI  R30,HIGH(@0)
	CPC  R27,R30
	LDI  R30,BYTE3(@0)
	CPC  R24,R30
	LDI  R30,BYTE4(@0)
	CPC  R25,R30
	.ENDM

	.MACRO __CPWRR
	CP   R@0,R@2
	CPC  R@1,R@3
	.ENDM

	.MACRO __CPWRN
	CPI  R@0,LOW(@2)
	LDI  R30,HIGH(@2)
	CPC  R@1,R30
	.ENDM

	.MACRO __ADDB1MN
	SUBI R30,LOW(-@0-(@1))
	.ENDM

	.MACRO __ADDB2MN
	SUBI R26,LOW(-@0-(@1))
	.ENDM

	.MACRO __ADDW1MN
	SUBI R30,LOW(-@0-(@1))
	SBCI R31,HIGH(-@0-(@1))
	.ENDM

	.MACRO __ADDW2MN
	SUBI R26,LOW(-@0-(@1))
	SBCI R27,HIGH(-@0-(@1))
	.ENDM

	.MACRO __ADDW1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	.ENDM

	.MACRO __ADDD1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	SBCI R22,BYTE3(-2*@0-(@1))
	.ENDM

	.MACRO __ADDD1N
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	SBCI R22,BYTE3(-@0)
	SBCI R23,BYTE4(-@0)
	.ENDM

	.MACRO __ADDD2N
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	SBCI R24,BYTE3(-@0)
	SBCI R25,BYTE4(-@0)
	.ENDM

	.MACRO __SUBD1N
	SUBI R30,LOW(@0)
	SBCI R31,HIGH(@0)
	SBCI R22,BYTE3(@0)
	SBCI R23,BYTE4(@0)
	.ENDM

	.MACRO __SUBD2N
	SUBI R26,LOW(@0)
	SBCI R27,HIGH(@0)
	SBCI R24,BYTE3(@0)
	SBCI R25,BYTE4(@0)
	.ENDM

	.MACRO __ANDBMNN
	LDS  R30,@0+(@1)
	ANDI R30,LOW(@2)
	STS  @0+(@1),R30
	.ENDM

	.MACRO __ANDWMNN
	LDS  R30,@0+(@1)
	ANDI R30,LOW(@2)
	STS  @0+(@1),R30
	LDS  R30,@0+(@1)+1
	ANDI R30,HIGH(@2)
	STS  @0+(@1)+1,R30
	.ENDM

	.MACRO __ANDD1N
	ANDI R30,LOW(@0)
	ANDI R31,HIGH(@0)
	ANDI R22,BYTE3(@0)
	ANDI R23,BYTE4(@0)
	.ENDM

	.MACRO __ANDD2N
	ANDI R26,LOW(@0)
	ANDI R27,HIGH(@0)
	ANDI R24,BYTE3(@0)
	ANDI R25,BYTE4(@0)
	.ENDM

	.MACRO __ORBMNN
	LDS  R30,@0+(@1)
	ORI  R30,LOW(@2)
	STS  @0+(@1),R30
	.ENDM

	.MACRO __ORWMNN
	LDS  R30,@0+(@1)
	ORI  R30,LOW(@2)
	STS  @0+(@1),R30
	LDS  R30,@0+(@1)+1
	ORI  R30,HIGH(@2)
	STS  @0+(@1)+1,R30
	.ENDM

	.MACRO __ORD1N
	ORI  R30,LOW(@0)
	ORI  R31,HIGH(@0)
	ORI  R22,BYTE3(@0)
	ORI  R23,BYTE4(@0)
	.ENDM

	.MACRO __ORD2N
	ORI  R26,LOW(@0)
	ORI  R27,HIGH(@0)
	ORI  R24,BYTE3(@0)
	ORI  R25,BYTE4(@0)
	.ENDM

	.MACRO __DELAY_USB
	LDI  R24,LOW(@0)
__DELAY_USB_LOOP:
	DEC  R24
	BRNE __DELAY_USB_LOOP
	.ENDM

	.MACRO __DELAY_USW
	LDI  R24,LOW(@0)
	LDI  R25,HIGH(@0)
__DELAY_USW_LOOP:
	SBIW R24,1
	BRNE __DELAY_USW_LOOP
	.ENDM

	.MACRO __GETD1S
	LDD  R30,Y+@0
	LDD  R31,Y+@0+1
	LDD  R22,Y+@0+2
	LDD  R23,Y+@0+3
	.ENDM

	.MACRO __GETD2S
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	LDD  R24,Y+@0+2
	LDD  R25,Y+@0+3
	.ENDM

	.MACRO __PUTD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R31
	STD  Y+@0+2,R22
	STD  Y+@0+3,R23
	.ENDM

	.MACRO __PUTD2S
	STD  Y+@0,R26
	STD  Y+@0+1,R27
	STD  Y+@0+2,R24
	STD  Y+@0+3,R25
	.ENDM

	.MACRO __PUTDZ2
	STD  Z+@0,R26
	STD  Z+@0+1,R27
	STD  Z+@0+2,R24
	STD  Z+@0+3,R25
	.ENDM

	.MACRO __CLRD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R30
	STD  Y+@0+2,R30
	STD  Y+@0+3,R30
	.ENDM

	.MACRO __POINTB1MN
	LDI  R30,LOW(@0+(@1))
	.ENDM

	.MACRO __POINTW1MN
	LDI  R30,LOW(@0+(@1))
	LDI  R31,HIGH(@0+(@1))
	.ENDM

	.MACRO __POINTD1M
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __POINTW1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	.ENDM

	.MACRO __POINTD1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	LDI  R22,BYTE3(2*@0+(@1))
	LDI  R23,BYTE4(2*@0+(@1))
	.ENDM

	.MACRO __POINTB2MN
	LDI  R26,LOW(@0+(@1))
	.ENDM

	.MACRO __POINTW2MN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	.ENDM

	.MACRO __POINTW2FN
	LDI  R26,LOW(2*@0+(@1))
	LDI  R27,HIGH(2*@0+(@1))
	.ENDM

	.MACRO __POINTD2FN
	LDI  R26,LOW(2*@0+(@1))
	LDI  R27,HIGH(2*@0+(@1))
	LDI  R24,BYTE3(2*@0+(@1))
	LDI  R25,BYTE4(2*@0+(@1))
	.ENDM

	.MACRO __POINTBRM
	LDI  R@0,LOW(@1)
	.ENDM

	.MACRO __POINTWRM
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __POINTBRMN
	LDI  R@0,LOW(@1+(@2))
	.ENDM

	.MACRO __POINTWRMN
	LDI  R@0,LOW(@2+(@3))
	LDI  R@1,HIGH(@2+(@3))
	.ENDM

	.MACRO __POINTWRFN
	LDI  R@0,LOW(@2*2+(@3))
	LDI  R@1,HIGH(@2*2+(@3))
	.ENDM

	.MACRO __GETD1N
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __GETD2N
	LDI  R26,LOW(@0)
	LDI  R27,HIGH(@0)
	LDI  R24,BYTE3(@0)
	LDI  R25,BYTE4(@0)
	.ENDM

	.MACRO __GETB1MN
	LDS  R30,@0+(@1)
	.ENDM

	.MACRO __GETB1HMN
	LDS  R31,@0+(@1)
	.ENDM

	.MACRO __GETW1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	.ENDM

	.MACRO __GETD1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	LDS  R22,@0+(@1)+2
	LDS  R23,@0+(@1)+3
	.ENDM

	.MACRO __GETBRMN
	LDS  R@0,@1+(@2)
	.ENDM

	.MACRO __GETWRMN
	LDS  R@0,@2+(@3)
	LDS  R@1,@2+(@3)+1
	.ENDM

	.MACRO __GETWRZ
	LDD  R@0,Z+@2
	LDD  R@1,Z+@2+1
	.ENDM

	.MACRO __GETD2Z
	LDD  R26,Z+@0
	LDD  R27,Z+@0+1
	LDD  R24,Z+@0+2
	LDD  R25,Z+@0+3
	.ENDM

	.MACRO __GETB2MN
	LDS  R26,@0+(@1)
	.ENDM

	.MACRO __GETW2MN
	LDS  R26,@0+(@1)
	LDS  R27,@0+(@1)+1
	.ENDM

	.MACRO __GETD2MN
	LDS  R26,@0+(@1)
	LDS  R27,@0+(@1)+1
	LDS  R24,@0+(@1)+2
	LDS  R25,@0+(@1)+3
	.ENDM

	.MACRO __PUTB1MN
	STS  @0+(@1),R30
	.ENDM

	.MACRO __PUTW1MN
	STS  @0+(@1),R30
	STS  @0+(@1)+1,R31
	.ENDM

	.MACRO __PUTD1MN
	STS  @0+(@1),R30
	STS  @0+(@1)+1,R31
	STS  @0+(@1)+2,R22
	STS  @0+(@1)+3,R23
	.ENDM

	.MACRO __PUTB1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	RCALL __EEPROMWRB
	.ENDM

	.MACRO __PUTW1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	RCALL __EEPROMWRW
	.ENDM

	.MACRO __PUTD1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	RCALL __EEPROMWRD
	.ENDM

	.MACRO __PUTBR0MN
	STS  @0+(@1),R0
	.ENDM

	.MACRO __PUTBMRN
	STS  @0+(@1),R@2
	.ENDM

	.MACRO __PUTWMRN
	STS  @0+(@1),R@2
	STS  @0+(@1)+1,R@3
	.ENDM

	.MACRO __PUTBZR
	STD  Z+@1,R@0
	.ENDM

	.MACRO __PUTWZR
	STD  Z+@2,R@0
	STD  Z+@2+1,R@1
	.ENDM

	.MACRO __GETW1R
	MOV  R30,R@0
	MOV  R31,R@1
	.ENDM

	.MACRO __GETW2R
	MOV  R26,R@0
	MOV  R27,R@1
	.ENDM

	.MACRO __GETWRN
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __PUTW1R
	MOV  R@0,R30
	MOV  R@1,R31
	.ENDM

	.MACRO __PUTW2R
	MOV  R@0,R26
	MOV  R@1,R27
	.ENDM

	.MACRO __ADDWRN
	SUBI R@0,LOW(-@2)
	SBCI R@1,HIGH(-@2)
	.ENDM

	.MACRO __ADDWRR
	ADD  R@0,R@2
	ADC  R@1,R@3
	.ENDM

	.MACRO __SUBWRN
	SUBI R@0,LOW(@2)
	SBCI R@1,HIGH(@2)
	.ENDM

	.MACRO __SUBWRR
	SUB  R@0,R@2
	SBC  R@1,R@3
	.ENDM

	.MACRO __ANDWRN
	ANDI R@0,LOW(@2)
	ANDI R@1,HIGH(@2)
	.ENDM

	.MACRO __ANDWRR
	AND  R@0,R@2
	AND  R@1,R@3
	.ENDM

	.MACRO __ORWRN
	ORI  R@0,LOW(@2)
	ORI  R@1,HIGH(@2)
	.ENDM

	.MACRO __ORWRR
	OR   R@0,R@2
	OR   R@1,R@3
	.ENDM

	.MACRO __EORWRR
	EOR  R@0,R@2
	EOR  R@1,R@3
	.ENDM

	.MACRO __GETWRS
	LDD  R@0,Y+@2
	LDD  R@1,Y+@2+1
	.ENDM

	.MACRO __PUTBSR
	STD  Y+@1,R@0
	.ENDM

	.MACRO __PUTWSR
	STD  Y+@2,R@0
	STD  Y+@2+1,R@1
	.ENDM

	.MACRO __MOVEWRR
	MOV  R@0,R@2
	MOV  R@1,R@3
	.ENDM

	.MACRO __INWR
	IN   R@0,@2
	IN   R@1,@2+1
	.ENDM

	.MACRO __OUTWR
	OUT  @2+1,R@1
	OUT  @2,R@0
	.ENDM

	.MACRO __CALL1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	ICALL
	.ENDM

	.MACRO __CALL1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	RCALL __GETW1PF
	ICALL
	.ENDM

	.MACRO __CALL2EN
	PUSH R26
	PUSH R27
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	RCALL __EEPROMRDW
	POP  R27
	POP  R26
	ICALL
	.ENDM

	.MACRO __CALL2EX
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	RCALL __EEPROMRDD
	ICALL
	.ENDM

	.MACRO __GETW1STACK
	IN   R30,SPL
	IN   R31,SPH
	ADIW R30,@0+1
	LD   R0,Z+
	LD   R31,Z
	MOV  R30,R0
	.ENDM

	.MACRO __GETD1STACK
	IN   R30,SPL
	IN   R31,SPH
	ADIW R30,@0+1
	LD   R0,Z+
	LD   R1,Z+
	LD   R22,Z
	MOVW R30,R0
	.ENDM

	.MACRO __NBST
	BST  R@0,@1
	IN   R30,SREG
	LDI  R31,0x40
	EOR  R30,R31
	OUT  SREG,R30
	.ENDM


	.MACRO __PUTB1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RNS
	MOVW R26,R@0
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	RCALL __PUTDP1
	.ENDM


	.MACRO __GETB1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R30,Z
	.ENDM

	.MACRO __GETB1HSX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	.ENDM

	.MACRO __GETW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R31,Z
	MOV  R30,R0
	.ENDM

	.MACRO __GETD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R1,Z+
	LD   R22,Z+
	LD   R23,Z
	MOVW R30,R0
	.ENDM

	.MACRO __GETB2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R26,X
	.ENDM

	.MACRO __GETW2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	.ENDM

	.MACRO __GETD2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R1,X+
	LD   R24,X+
	LD   R25,X
	MOVW R26,R0
	.ENDM

	.MACRO __GETBRSX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	LD   R@0,Z
	.ENDM

	.MACRO __GETWRSX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	LD   R@0,Z+
	LD   R@1,Z
	.ENDM

	.MACRO __GETBRSX2
	MOVW R26,R28
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	LD   R@0,X
	.ENDM

	.MACRO __GETWRSX2
	MOVW R26,R28
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	LD   R@0,X+
	LD   R@1,X
	.ENDM

	.MACRO __LSLW8SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	CLR  R30
	.ENDM

	.MACRO __PUTB1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __CLRW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R30
	.ENDM

	.MACRO __CLRD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R30
	ST   X+,R30
	ST   X,R30
	.ENDM

	.MACRO __PUTB2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R26
	.ENDM

	.MACRO __PUTW2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z,R27
	.ENDM

	.MACRO __PUTD2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z+,R27
	ST   Z+,R24
	ST   Z,R25
	.ENDM

	.MACRO __PUTBSRX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	ST   Z,R@0
	.ENDM

	.MACRO __PUTWSRX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	ST   Z+,R@0
	ST   Z,R@1
	.ENDM

	.MACRO __PUTB1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __MULBRR
	MULS R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRRU
	MUL  R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRR0
	MULS R@0,R@1
	.ENDM

	.MACRO __MULBRRU0
	MUL  R@0,R@1
	.ENDM

	.MACRO __MULBNWRU
	LDI  R26,@2
	MUL  R26,R@0
	MOVW R30,R0
	MUL  R26,R@1
	ADD  R31,R0
	.ENDM

;NAME DEFINITIONS FOR GLOBAL VARIABLES ALLOCATED TO REGISTERS
	.DEF _devices=R5
	.DEF _A=R6
	.DEF _A_msb=R7
	.DEF _B=R8
	.DEF _B_msb=R9
	.DEF _C=R10
	.DEF _C_msb=R11
	.DEF _D=R12
	.DEF _D_msb=R13
	.DEF _At=R4

	.CSEG
	.ORG 0x00

;START OF CODE MARKER
__START_OF_CODE:

;INTERRUPT VECTORS
	RJMP __RESET
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP _timer1_ovf_isr
	RJMP 0x00
	RJMP 0x00
	RJMP _usart_rx_isr
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP _ana_comp_isr
	RJMP 0x00
	RJMP 0x00

_cmd_0:
	.DB  0x41,0x54,0x2B,0x49,0x50,0x52,0x3D,0x39
	.DB  0x36,0x30,0x30,0x0
_cmd_1:
	.DB  0x41,0x54,0x0
_cmd_2:
	.DB  0x41,0x54,0x2B,0x43,0x4D,0x47,0x46,0x3D
	.DB  0x31,0x0
_cmd_2_:
	.DB  0x41,0x54,0x2B,0x43,0x4D,0x47,0x46,0x3D
	.DB  0x30,0x0
_cmd_3:
	.DB  0x41,0x54,0x2B,0x43,0x4D,0x47,0x53,0x3D
	.DB  0x0
_cmd_4:
	.DB  0x41,0x54,0x48,0x30,0x0
_cmd_5:
	.DB  0x54,0x65,0x6D,0x70,0x65,0x72,0x20,0x0
_cmd_6:
	.DB  0x5A,0x76,0x6F,0x6E,0x6F,0x6B,0x20,0x0
_cmd_7:
	.DB  0x42,0x72,0x65,0x6C,0x6F,0x6B,0x20,0x0
_cmd_9:
	.DB  0x41,0x54,0x2B,0x43,0x4C,0x49,0x50,0x3D
	.DB  0x31,0x0
_cmd_10:
	.DB  0x41,0x54,0x44,0x2B,0x20,0x0
_cmd_11:
	.DB  0x43,0x6C,0x65,0x61,0x72,0x20,0x54,0x65
	.DB  0x6C,0x0
_cmd_12:
	.DB  0x4E,0x65,0x77,0x20,0x54,0x65,0x6C,0x0
_cmd_13:
	.DB  0x41,0x54,0x2B,0x43,0x4D,0x47,0x44,0x41
	.DB  0x3D,0x0
_cmd_13_:
	.DB  0x44,0x45,0x4C,0x20,0x41,0x4C,0x4C,0x0
_cmd_14:
	.DB  0xA,0x54,0x65,0x6D,0x20,0x0
_conv_delay_G100:
	.DB  0x64,0x0,0xC8,0x0,0x90,0x1,0x20,0x3
_bit_mask_G100:
	.DB  0xF8,0xFF,0xFC,0xFF,0xFE,0xFF,0xFF,0xFF

;GLOBAL REGISTER VARIABLES INITIALIZATION
__REG_VARS:
	.DB  0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0
	.DB  0x0


__GLOBAL_INI_TBL:
	.DW  0x09
	.DW  0x05
	.DW  __REG_VARS*2

_0xFFFFFFFF:
	.DW  0

#define __GLOBAL_INI_TBL_PRESENT 1

__RESET:
	CLI
	CLR  R30
	OUT  EECR,R30

;INTERRUPT VECTORS ARE PLACED
;AT THE START OF FLASH
	LDI  R31,1
	OUT  GICR,R31
	OUT  GICR,R30
	OUT  MCUCR,R30

;CLEAR R2-R14
	LDI  R24,(14-2)+1
	LDI  R26,2
	CLR  R27
__CLEAR_REG:
	ST   X+,R30
	DEC  R24
	BRNE __CLEAR_REG

;CLEAR SRAM
	LDI  R24,LOW(__CLEAR_SRAM_SIZE)
	LDI  R25,HIGH(__CLEAR_SRAM_SIZE)
	LDI  R26,__SRAM_START
__CLEAR_SRAM:
	ST   X+,R30
	SBIW R24,1
	BRNE __CLEAR_SRAM

;GLOBAL VARIABLES INITIALIZATION
	LDI  R30,LOW(__GLOBAL_INI_TBL*2)
	LDI  R31,HIGH(__GLOBAL_INI_TBL*2)
__GLOBAL_INI_NEXT:
	LPM  R24,Z+
	LPM  R25,Z+
	SBIW R24,0
	BREQ __GLOBAL_INI_END
	LPM  R26,Z+
	LPM  R27,Z+
	LPM  R0,Z+
	LPM  R1,Z+
	MOVW R22,R30
	MOVW R30,R0
__GLOBAL_INI_LOOP:
	LPM  R0,Z+
	ST   X+,R0
	SBIW R24,1
	BRNE __GLOBAL_INI_LOOP
	MOVW R30,R22
	RJMP __GLOBAL_INI_NEXT
__GLOBAL_INI_END:

;HARDWARE STACK POINTER INITIALIZATION
	LDI  R30,LOW(__SRAM_END-__HEAP_SIZE)
	OUT  SPL,R30
	LDI  R30,HIGH(__SRAM_END-__HEAP_SIZE)
	OUT  SPH,R30

;DATA STACK POINTER INITIALIZATION
	LDI  R28,LOW(__SRAM_START+__DSTACK_SIZE)
	LDI  R29,HIGH(__SRAM_START+__DSTACK_SIZE)

	RJMP _main

	.ESEG
	.ORG 0

	.DSEG
	.ORG 0x160

	.CSEG
;/*******************************************************
;This program was created by the
;CodeWizardAVR V3.12 Advanced
;Automatic Program Generator
; Copyright 1998-2014 Pavel Haiduc, HP InfoTech s.r.l.
;http://www.hpinfotech.com
;
;Project : Auto Zapusk GSM
;Version :
;Date    : 16.02.2024
;Author  :  ..
;Company : Home
;Comments:      :   ,   ( 
;    5    2 )       
;4 1 (    -17 .)   4    PORT D4 ( 6)  GND  ...
;     DS18b20.
;  7 .
;
;
;Chip type               : ATmega8
;Program type            : Application
;AVR Core Clock frequency: 4,000000 MHz
;Memory model            : Small
;External RAM size       : 0
;Data Stack size         : 256
;*******************************************************/
;#include <mega8.h>
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x80
	.EQU __sm_mask=0x70
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0x60
	.EQU __sm_ext_standby=0x70
	.EQU __sm_adc_noise_red=0x10
	.SET power_ctrl_reg=mcucr
	#endif
;#include <delay.h>                                      // 
;#include <ds18b20.h>                                    //     ds18b20
;
;
;// Declare your global variables here
;#define MAX_DS18B20 8
;float temp1;// ,temp2;                  //     
;unsigned char devices=0;                      //     DS18b20
;unsigned char rom_code[2][9];               //     [4][9] 4 .
;unsigned int A,B,C,D=0;
;unsigned char At,Bt,Ct, Dt=0;
;//int Ct1 = 0;
;int znak = 0;                              //    
;unsigned int Bt1 = 0;
;
;
;#define _Tel_OFF 300
;#define RX_BUFFER_SIZE 150
;#define FRAMING_ERROR (1<<FE)
;#define PARITY_ERROR (1<<UPE)
;#define DATA_REGISTER_EMPTY (1<<UDRE)
;#define RX_COMPLETE (1<<RXC)
;#define _tim_end 60                    //   ds18b20   
;#define _timer_perep 61628
;#asm
   .equ __w1_port=0x15 ;PORTC           //   
   .equ __w1_bit=5
; 0000 0037 #endasm
;
;unsigned char i, rx_cursor; //  ()   
;char MyBuffer[RX_BUFFER_SIZE];                          //    SMS    
;unsigned int z;                                         //    
;flash unsigned char cmd_0[]={"AT+IPR=9600"};            //    UART
;flash unsigned char cmd_1[]={"AT"};                     //        ( 0)
;flash unsigned char cmd_2[]={"AT+CMGF=1"};              //  SMS  
;flash unsigned char cmd_2_[]={"AT+CMGF=0"};             //   
;flash unsigned char cmd_3[]={"AT+CMGS="};               //  SMS   
;flash unsigned char cmd_4[]={"ATH0"};                   //   ( )
;flash unsigned char cmd_5[]={"Temper "};                //  
;flash unsigned char cmd_6[]={"Zvonok "};                //  
;flash unsigned char cmd_7[]={"Brelok "};                //  
;flash unsigned char cmd_9[]={"AT+CLIP=1"};              //     - 
;flash unsigned char cmd_10[]={"ATD+ "};                 //    "ATD+ +7xxxxxxxxxx;"
;flash unsigned char cmd_11[]={"Clear Tel"};             //   "   "
;flash unsigned char cmd_12[]={"New Tel"};               //   "    "
;flash unsigned char cmd_13[]={"AT+CMGDA="};             //  
;flash unsigned char cmd_13_[]={"DEL ALL"};              //              SMS.
;flash unsigned char cmd_14[]={"\nTem "};               //      "Tem -17"
;unsigned char cmd_8[13]={0};                            //  
;int _flag = 0;                                          //   SMS  
;int Temperat = 0;                                       // .   .   
;int _Err = 0;                                           // -      5  ( 2)
;int _Err_out = 0;                                       //   -      (=1)
;int _Blokir = 0;                                        //     ( pfgecrjv ( ...
;int _Tel = 0;                                           //      (  )
;int Ring = 0;                                           //    = 4
;int Deact = 0;                                          //     -   "DEACT"  Deact==5  ...
;char _Tel_SMS = 0;                                      //    0=SMS 1=Zvonok
;int _tim = 0;                                           //    ds18b20
;__eeprom unsigned char cmd_8e[]={"+79123456789"};       //  
;__eeprom char _Tel_SMS_E = 0;                           //    0=SMS 1=Zvonok
;//=======================================================================
;// Timer1 overflow interrupt service routine
;interrupt [TIM1_OVF] void timer1_ovf_isr(void)
; 0000 005C {

	.CSEG
_timer1_ovf_isr:
; .FSTART _timer1_ovf_isr
	RCALL SUBOPT_0x0
; 0000 005D // Place your code here
; 0000 005E _tim++;
	LDI  R26,LOW(__tim)
	LDI  R27,HIGH(__tim)
	RCALL SUBOPT_0x1
; 0000 005F TCNT1 = _timer_perep;
	LDI  R30,LOW(61628)
	LDI  R31,HIGH(61628)
	OUT  0x2C+1,R31
	OUT  0x2C,R30
; 0000 0060 }
	RCALL SUBOPT_0x2
	RETI
; .FEND
;//------------------------------------------
;// USART Receiver interrupt service routine
;interrupt [USART_RXC] void usart_rx_isr(void)
; 0000 0064     {
_usart_rx_isr:
; .FSTART _usart_rx_isr
	RCALL SUBOPT_0x0
; 0000 0065     char status, data;
; 0000 0066     status=UCSRA;
	RCALL __SAVELOCR2
;	status -> R17
;	data -> R16
	IN   R17,11
; 0000 0067     data=UDR;
	IN   R16,12
; 0000 0068     if ((status & (FRAMING_ERROR | PARITY_ERROR )) ==0) //| DATA_OVERRUN))==0)
	MOV  R30,R17
	ANDI R30,LOW(0x14)
; 0000 0069       {
; 0000 006A 
; 0000 006B         }
; 0000 006C       if (Ring!=4)
	RCALL SUBOPT_0x3
	SBIW R26,4
	BREQ _0x4
; 0000 006D         {
; 0000 006E         if (data=='R') Ring=1;
	CPI  R16,82
	BRNE _0x5
	RCALL SUBOPT_0x4
	STS  _Ring,R30
	STS  _Ring+1,R31
; 0000 006F         if (data=='I')
_0x5:
	CPI  R16,73
	BRNE _0x6
; 0000 0070             {
; 0000 0071             if (Ring==1) Ring++;
	RCALL SUBOPT_0x3
	SBIW R26,1
	BRNE _0x7
	RCALL SUBOPT_0x5
; 0000 0072             else  Ring=0;
	RJMP _0x8
_0x7:
	RCALL SUBOPT_0x6
; 0000 0073             }
_0x8:
; 0000 0074         if (data=='N')
_0x6:
	CPI  R16,78
	BRNE _0x9
; 0000 0075             {
; 0000 0076             if (Ring==2) Ring++;
	RCALL SUBOPT_0x3
	SBIW R26,2
	BRNE _0xA
	RCALL SUBOPT_0x5
; 0000 0077             else  Ring=0;
	RJMP _0xB
_0xA:
	RCALL SUBOPT_0x6
; 0000 0078             }
_0xB:
; 0000 0079         if (data=='G')
_0x9:
	CPI  R16,71
	BRNE _0xC
; 0000 007A             {
; 0000 007B             if (Ring==3) Ring++;                    // Ring = 4   
	RCALL SUBOPT_0x3
	SBIW R26,3
	BRNE _0xD
	RCALL SUBOPT_0x5
; 0000 007C             else  Ring=0;
	RJMP _0xE
_0xD:
	RCALL SUBOPT_0x6
; 0000 007D             }
_0xE:
; 0000 007E         }
_0xC:
; 0000 007F       if (Deact!=5)
_0x4:
	RCALL SUBOPT_0x7
	SBIW R26,5
	BREQ _0xF
; 0000 0080         {
; 0000 0081         if (data=='D') Deact=1;                        //     -   "DEACT"
	CPI  R16,68
	BRNE _0x10
	RCALL SUBOPT_0x4
	STS  _Deact,R30
	STS  _Deact+1,R31
; 0000 0082         if (data=='E')                                 //  Deact==5    GPS 
_0x10:
	CPI  R16,69
	BRNE _0x11
; 0000 0083             {
; 0000 0084             if (Deact==1) Deact++;
	RCALL SUBOPT_0x7
	SBIW R26,1
	BRNE _0x12
	RCALL SUBOPT_0x8
; 0000 0085             else  Deact=0;
	RJMP _0x13
_0x12:
	RCALL SUBOPT_0x9
; 0000 0086             }
_0x13:
; 0000 0087         if (data=='A')
_0x11:
	CPI  R16,65
	BRNE _0x14
; 0000 0088             {
; 0000 0089             if (Deact==2) Deact++;
	RCALL SUBOPT_0x7
	SBIW R26,2
	BRNE _0x15
	RCALL SUBOPT_0x8
; 0000 008A             else  Deact=0;
	RJMP _0x16
_0x15:
	RCALL SUBOPT_0x9
; 0000 008B             }
_0x16:
; 0000 008C         if (data=='C')
_0x14:
	CPI  R16,67
	BRNE _0x17
; 0000 008D             {
; 0000 008E             if (Deact==3) Deact++;
	RCALL SUBOPT_0x7
	SBIW R26,3
	BRNE _0x18
	RCALL SUBOPT_0x8
; 0000 008F             else  Deact=0;
	RJMP _0x19
_0x18:
	RCALL SUBOPT_0x9
; 0000 0090             }
_0x19:
; 0000 0091         if (data=='T')
_0x17:
	CPI  R16,84
	BRNE _0x1A
; 0000 0092             {
; 0000 0093             if (Deact==4) Deact++;
	RCALL SUBOPT_0x7
	SBIW R26,4
	BRNE _0x1B
	RCALL SUBOPT_0x8
; 0000 0094             else  Deact=0;
	RJMP _0x1C
_0x1B:
	RCALL SUBOPT_0x9
; 0000 0095             }
_0x1C:
; 0000 0096 
; 0000 0097         if((data==0x0d)||(data==0x0a))
_0x1A:
	CPI  R16,13
	BREQ _0x1E
	CPI  R16,10
	BRNE _0x1D
_0x1E:
; 0000 0098             {
; 0000 0099             if(i>0)
	LDS  R26,_i
	CPI  R26,LOW(0x1)
	BRLO _0x20
; 0000 009A                 {
; 0000 009B                 data = 0;
	LDI  R16,LOW(0)
; 0000 009C                 }
; 0000 009D             }
_0x20:
; 0000 009E         MyBuffer[i]=data;
_0x1D:
	LDS  R30,_i
	RCALL SUBOPT_0xA
	ST   Z,R16
; 0000 009F         i ++;                                       //  
	LDS  R30,_i
	SUBI R30,-LOW(1)
	RCALL SUBOPT_0xB
; 0000 00A0         if (i == RX_BUFFER_SIZE)                    //     
	LDS  R26,_i
	CPI  R26,LOW(0x96)
	BRNE _0x21
; 0000 00A1             {                                       //     
; 0000 00A2             i=0;                                    //   = 0
	LDI  R30,LOW(0)
	RCALL SUBOPT_0xB
; 0000 00A3             }
; 0000 00A4 
; 0000 00A5       }
_0x21:
; 0000 00A6     }
_0xF:
	LD   R16,Y+
	LD   R17,Y+
	RCALL SUBOPT_0x2
	RETI
; .FEND
;//-----------------------------------------------------------------
;// Analog Comparator interrupt service routine
;//-----------------------------------------------------------------
;interrupt [ANA_COMP] void ana_comp_isr(void)
; 0000 00AB {
_ana_comp_isr:
; .FSTART _ana_comp_isr
	ST   -Y,R30
	ST   -Y,R31
; 0000 00AC // Place your code here
; 0000 00AD //if (PIND.4==0)
; 0000 00AE Temperat = 1;                        //  D4 = Gnd   -4 1   DS18b20
	RCALL SUBOPT_0xC
; 0000 00AF }
	LD   R31,Y+
	LD   R30,Y+
	RETI
; .FEND
;//=================================================================
;//-----------------------------------------------------------------
;//     SMS
;void chislo( int cislo)                             //        
; 0000 00B4     {                                               //  -  D C B A
_chislo:
; .FSTART _chislo
; 0000 00B5     A = B = C  = cislo;
	RCALL SUBOPT_0xD
;	cislo -> Y+0
	LD   R30,Y
	LDD  R31,Y+1
	MOVW R10,R30
	MOVW R8,R30
	MOVW R6,R30
; 0000 00B6     C = C / 100 ;                                   //    (  100)
	MOVW R26,R10
	LDI  R30,LOW(100)
	LDI  R31,HIGH(100)
	RCALL __DIVW21U
	MOVW R10,R30
; 0000 00B7     B = A = B % 100 ;                               //     100
	MOVW R26,R8
	LDI  R30,LOW(100)
	LDI  R31,HIGH(100)
	RCALL __MODW21U
	MOVW R6,R30
	MOVW R8,R30
; 0000 00B8     B = B / 10 ;                                    //    (  10)
	MOVW R26,R8
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	RCALL __DIVW21U
	MOVW R8,R30
; 0000 00B9     A = A % 10 ;                                    //     (     10)
	MOVW R26,R6
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	RCALL __MODW21U
	MOVW R6,R30
; 0000 00BA 
; 0000 00BB     if (znak>0) D=0x2d;
	RCALL SUBOPT_0xE
	RCALL __CPW02
	BRGE _0x22
	LDI  R30,LOW(45)
	LDI  R31,HIGH(45)
	RJMP _0x197
; 0000 00BC     else D = '+';
_0x22:
	LDI  R30,LOW(43)
	LDI  R31,HIGH(43)
_0x197:
	MOVW R12,R30
; 0000 00BD     if (C==0)                                       //       (  )   ...
	MOV  R0,R10
	OR   R0,R11
	BRNE _0x24
; 0000 00BE         {
; 0000 00BF         C=D;
	MOVW R10,R12
; 0000 00C0         D=0x20;
	LDI  R30,LOW(32)
	LDI  R31,HIGH(32)
	MOVW R12,R30
; 0000 00C1         }
; 0000 00C2 
; 0000 00C3     Dt=D;
_0x24:
	STS  _Dt,R12
; 0000 00C4     if (C<10) Ct=C|0x30;
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	CP   R10,R30
	CPC  R11,R31
	BRSH _0x25
	MOV  R30,R10
	ORI  R30,LOW(0x30)
	STS  _Ct,R30
; 0000 00C5     else Ct=C;
	RJMP _0x26
_0x25:
	STS  _Ct,R10
; 0000 00C6     Bt=B|0x30;
_0x26:
	MOV  R30,R8
	ORI  R30,LOW(0x30)
	STS  _Bt,R30
; 0000 00C7     At=A|0x30;
	MOV  R30,R6
	ORI  R30,LOW(0x30)
	MOV  R4,R30
; 0000 00C8     }
	ADIW R28,2
	RET
; .FEND
;//-------------------------------------------------------------
;//-------------    DS18b20 --------------
;//-------------------------------------------------------------
;void _Temper(void)                                  //      
; 0000 00CD     {
__Temper:
; .FSTART __Temper
; 0000 00CE 
; 0000 00CF     if (devices==0)
	TST  R5
	BRNE _0x27
; 0000 00D0         {
; 0000 00D1         devices=w1_search(DS18B20_SEARCH_ROM_CMD,rom_code);             //        ...
	LDI  R30,LOW(240)
	ST   -Y,R30
	LDI  R26,LOW(_rom_code)
	LDI  R27,HIGH(_rom_code)
	RCALL _w1_search
	MOV  R5,R30
; 0000 00D2         ds18b20_init(0,-35,35,DS18B20_12BIT_RES);//DS18B20_12BIT_RES);  //    12  
	RCALL SUBOPT_0xF
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(221)
	ST   -Y,R30
	LDI  R30,LOW(35)
	ST   -Y,R30
	LDI  R26,LOW(3)
	RCALL _ds18b20_init
; 0000 00D3         delay_ms(500);
	RCALL SUBOPT_0x10
; 0000 00D4         }
; 0000 00D5     else {
	RJMP _0x28
_0x27:
; 0000 00D6         temp1 = ds18b20_temperature(&rom_code[0][0]);  //     
	LDI  R26,LOW(_rom_code)
	LDI  R27,HIGH(_rom_code)
	RCALL _ds18b20_temperature
	RCALL SUBOPT_0x11
; 0000 00D7         if ((temp1 < 100) & (temp1 > -60))      //   
	RCALL SUBOPT_0x12
	__GETD1N 0x42C80000
	RCALL __LTF12
	MOV  R0,R30
	RCALL SUBOPT_0x12
	__GETD1N 0xC2700000
	RCALL __GTF12
	AND  R30,R0
	BREQ _0x29
; 0000 00D8             {
; 0000 00D9             //temp1= temp1;
; 0000 00DA             if (temp1>0)znak=0;                 //    - (   znak=1)
	RCALL SUBOPT_0x12
	RCALL __CPD02
	BRGE _0x2A
	LDI  R30,LOW(0)
	STS  _znak,R30
	STS  _znak+1,R30
; 0000 00DB             else znak=1;
	RJMP _0x2B
_0x2A:
	RCALL SUBOPT_0x4
	STS  _znak,R30
	STS  _znak+1,R31
; 0000 00DC             temp1=temp1*10;                     //   (     
_0x2B:
	RCALL SUBOPT_0x12
	__GETD1N 0x41200000
	RCALL __MULF12
	RCALL SUBOPT_0x11
; 0000 00DD             if (znak==1)
	RCALL SUBOPT_0xE
	SBIW R26,1
	BRNE _0x2C
; 0000 00DE                 {
; 0000 00DF                 temp1 = -temp1;                 //         
	RCALL SUBOPT_0x13
	RCALL __ANEGF1
	RCALL SUBOPT_0x11
; 0000 00E0                 //if ((PIND.4==1) & (temp1>160)) Temperat = 1;     //  D4 = 1  DS18b20     -16"C  ...
; 0000 00E1                 if (temp1>160) Temperat = 1;     //  D4 = 1  DS18b20     -16"C   
	RCALL SUBOPT_0x12
	__GETD1N 0x43200000
	RCALL __CMPF12
	BREQ PC+2
	BRCC PC+2
	RJMP _0x2D
	RCALL SUBOPT_0xC
; 0000 00E2                 }
_0x2D:
; 0000 00E3             Bt1 = (int) temp1;
_0x2C:
	RCALL SUBOPT_0x13
	RCALL __CFD1
	STS  _Bt1,R30
	STS  _Bt1+1,R31
; 0000 00E4             chislo(Bt1);                        //        
	LDS  R26,_Bt1
	LDS  R27,_Bt1+1
	RCALL _chislo
; 0000 00E5             }
; 0000 00E6         }
_0x29:
_0x28:
; 0000 00E7     }
	RET
; .FEND
;//-----------------------------------------------------------------
;//-------       ----------
;//-----------------------------------------------------------------
;int AON_(void)
; 0000 00EC     { char y, x =0;
_AON_:
; .FSTART _AON_
; 0000 00ED     rx_cursor = 0;                                  //   (    UART)
	RCALL __SAVELOCR2
;	y -> R17
;	x -> R16
	LDI  R16,0
	RCALL SUBOPT_0x14
; 0000 00EE     delay_ms(1000);                                 //       
	RCALL SUBOPT_0x15
; 0000 00EF     x = i;
	LDS  R16,_i
; 0000 00F0     #asm("cli")                                     //  
	cli
; 0000 00F1     i = 0;                                          //   UART 
	LDI  R30,LOW(0)
	RCALL SUBOPT_0xB
; 0000 00F2     #asm("sei")                                     //  
	sei
; 0000 00F3     if (x==0) return 0;                             //   -   
	CPI  R16,0
	BRNE _0x2E
	RCALL SUBOPT_0xF
	RJMP _0x2020006
; 0000 00F4     y=0;
_0x2E:
	LDI  R17,LOW(0)
; 0000 00F5 
; 0000 00F6     for ( rx_cursor=0;rx_cursor!=x;rx_cursor++)
	RCALL SUBOPT_0x14
_0x30:
	LDS  R26,_rx_cursor
	CP   R16,R26
	BREQ _0x31
; 0000 00F7         {
; 0000 00F8         if (y==12) return 1;                        //       
	CPI  R17,12
	BRNE _0x32
	RCALL SUBOPT_0x4
	RJMP _0x2020006
; 0000 00F9         if (rx_cursor==RX_BUFFER_SIZE) return 0;    //   -  
_0x32:
	LDS  R26,_rx_cursor
	CPI  R26,LOW(0x96)
	BRNE _0x33
	RCALL SUBOPT_0xF
	RJMP _0x2020006
; 0000 00FA         if (cmd_8[y]==MyBuffer[rx_cursor])
_0x33:
	MOV  R30,R17
	LDI  R31,0
	RCALL SUBOPT_0x16
	LD   R26,Z
	RCALL SUBOPT_0x17
	RCALL SUBOPT_0xA
	LD   R30,Z
	CP   R30,R26
	BRNE _0x34
; 0000 00FB             {
; 0000 00FC             y++;
	SUBI R17,-1
; 0000 00FD             }
; 0000 00FE         }
_0x34:
	RCALL SUBOPT_0x18
	RJMP _0x30
_0x31:
; 0000 00FF     if (y<12) return 0;                             //    (   )
	CPI  R17,12
	BRSH _0x35
	RCALL SUBOPT_0xF
	RJMP _0x2020006
; 0000 0100     }
_0x35:
	RJMP _0x2020006
; .FEND
;//-----------------------------------------------------------------
;//------------   ( ) --------------------
;//-----------------------------------------------------------------
;void Otboy(void)
; 0000 0105     {
_Otboy:
; .FSTART _Otboy
; 0000 0106 
; 0000 0107     for(z=0;cmd_4[z]!='';z++)                       //  
	RCALL SUBOPT_0x19
_0x37:
	RCALL SUBOPT_0x1A
	RCALL SUBOPT_0x1B
	BREQ _0x38
; 0000 0108         {
; 0000 0109         UDR = cmd_4[z];
	RCALL SUBOPT_0x1A
	RCALL SUBOPT_0x1C
; 0000 010A         delay_ms(100);
; 0000 010B         }
	RCALL SUBOPT_0x1D
	RJMP _0x37
_0x38:
; 0000 010C     UDR = ('\r');
	RCALL SUBOPT_0x1E
; 0000 010D     delay_ms(1500);
	LDI  R26,LOW(1500)
	LDI  R27,HIGH(1500)
	RCALL _delay_ms
; 0000 010E     }
	RET
; .FEND
;//----------------------------------------------------------
;//-----------   SMS ------------------------------
;//----------------------------------------------------------
;void Dell_SMS(void)                                 //   SMS "AT+CMGDA=DEL ALL"
; 0000 0113     {
; 0000 0114 
; 0000 0115     PORTC.3 = 1;                                    //   SMS
; 0000 0116     for(z=0;cmd_1[z]!='';z++)                       //     
; 0000 0117         {
; 0000 0118         UDR = cmd_1[z];
; 0000 0119         delay_ms(100);
; 0000 011A         }
; 0000 011B     UDR = ('\r');                                   //   ()
; 0000 011C     delay_ms(500);
; 0000 011D 
; 0000 011E     for(z=0;cmd_13[z]!='';z++)                       //  SMS  
; 0000 011F         {
; 0000 0120         UDR = cmd_13[z];
; 0000 0121         delay_ms(100);
; 0000 0122         }
; 0000 0123     UDR = ('"');
; 0000 0124     delay_ms(100);
; 0000 0125     for(z=0;cmd_13_[z]!='';z++)                     //    SMS ( AT+CMGDA=DEL ALL )
; 0000 0126         {
; 0000 0127         UDR = cmd_13_[z];
; 0000 0128         delay_ms(100);
; 0000 0129         }
; 0000 012A     UDR = ('"');
; 0000 012B     delay_ms(100);
; 0000 012C     UDR = ('\r');                                   //   ()
; 0000 012D 
; 0000 012E 
; 0000 012F     delay_ms(1500);
; 0000 0130     for(z=0;cmd_2_[z]!='';z++)                      //   
; 0000 0131         {
; 0000 0132         UDR = cmd_2_[z];
; 0000 0133         delay_ms(100);
; 0000 0134         }
; 0000 0135     UDR = ('\r');                                   //   ()
; 0000 0136     delay_ms(500);
; 0000 0137 
; 0000 0138     if (_flag==1)    PORTC.3 = 1;                   //     SMS     
; 0000 0139     else PORTC.3 = 0;
; 0000 013A     }
;//----------------------------------------------------------
;//-------------   GSM Sim800L --------------
;//----------------------------------------------------------
;void _Start_telef(void)
; 0000 013F     { int i;
__Start_telef:
; .FSTART __Start_telef
; 0000 0140 //   
; 0000 0141 PORTB.3 = 0;                                        //   GSM Sim800L
	RCALL __SAVELOCR2
;	i -> R16,R17
	CBI  0x18,3
; 0000 0142 for (i=0;i<2;i++)
	RCALL SUBOPT_0x1F
_0x50:
	__CPWRN 16,17,2
	BRGE _0x51
; 0000 0143     {                                               // 1   Reset = 0
; 0000 0144     PORTC.1 = 1;
	RCALL SUBOPT_0x20
; 0000 0145     delay_ms (100);
; 0000 0146     PORTC.2 = 1;
	RCALL SUBOPT_0x21
; 0000 0147     delay_ms (100);
; 0000 0148     PORTC.3 = 1;
	RCALL SUBOPT_0x22
; 0000 0149     delay_ms (100);
; 0000 014A     PORTC.1 = 0;
	RCALL SUBOPT_0x23
; 0000 014B     delay_ms (100);
; 0000 014C     PORTC.2 = 0;
	CBI  0x15,2
; 0000 014D     delay_ms (100);
	RCALL SUBOPT_0x24
; 0000 014E     PORTC.3 = 0;
	CBI  0x15,3
; 0000 014F     delay_ms (100);
	RCALL SUBOPT_0x24
; 0000 0150     }
	RCALL SUBOPT_0x25
	RJMP _0x50
_0x51:
; 0000 0151 PORTB.3 = 1;                                        //  Reset  GSM   Res = 1
	SBI  0x18,3
; 0000 0152 for (i=0;i<50;i++)
	RCALL SUBOPT_0x1F
_0x61:
	__CPWRN 16,17,50
	BRGE _0x62
; 0000 0153     {                                               //  20    
; 0000 0154     PORTC.3 = 1;
	RCALL SUBOPT_0x22
; 0000 0155     delay_ms (100);
; 0000 0156     PORTC.3 = 0;
	CBI  0x15,3
; 0000 0157     PORTC.2 = 1;
	RCALL SUBOPT_0x21
; 0000 0158     delay_ms (100);
; 0000 0159     PORTC.2 = 0;
	CBI  0x15,2
; 0000 015A     PORTC.1 = 1;
	RCALL SUBOPT_0x20
; 0000 015B     delay_ms (100);
; 0000 015C     PORTC.1 = 0;
	RCALL SUBOPT_0x23
; 0000 015D     delay_ms (100);
; 0000 015E     }
	RCALL SUBOPT_0x25
	RJMP _0x61
_0x62:
; 0000 015F     for(z=0;cmd_1[z]!='';z++)                       //     
	RCALL SUBOPT_0x19
_0x70:
	RCALL SUBOPT_0x26
	RCALL SUBOPT_0x1B
	BREQ _0x71
; 0000 0160         {
; 0000 0161         UDR = cmd_1[z];
	RCALL SUBOPT_0x26
	RCALL SUBOPT_0x1C
; 0000 0162         delay_ms(100);
; 0000 0163         }
	RCALL SUBOPT_0x1D
	RJMP _0x70
_0x71:
; 0000 0164     UDR = ('\r');
	RCALL SUBOPT_0x1E
; 0000 0165     delay_ms(500);
	RCALL SUBOPT_0x10
; 0000 0166     for(z=0;cmd_0[z]!='';z++)                       //    UART
	RCALL SUBOPT_0x19
_0x73:
	RCALL SUBOPT_0x27
	RCALL SUBOPT_0x1B
	BREQ _0x74
; 0000 0167         {
; 0000 0168         UDR = cmd_0[z];
	RCALL SUBOPT_0x27
	RCALL SUBOPT_0x1C
; 0000 0169         delay_ms(100);
; 0000 016A         }
	RCALL SUBOPT_0x1D
	RJMP _0x73
_0x74:
; 0000 016B     UDR = ('\r');
	RCALL SUBOPT_0x1E
; 0000 016C     delay_ms(500);
	RCALL SUBOPT_0x10
; 0000 016D     for(z=0;cmd_9[z]!='';z++)                       //     - 
	RCALL SUBOPT_0x19
_0x76:
	RCALL SUBOPT_0x28
	RCALL SUBOPT_0x1B
	BREQ _0x77
; 0000 016E         {
; 0000 016F         UDR = cmd_9[z];
	RCALL SUBOPT_0x28
	RCALL SUBOPT_0x1C
; 0000 0170         delay_ms(100);
; 0000 0171         }
	RCALL SUBOPT_0x1D
	RJMP _0x76
_0x77:
; 0000 0172     UDR = ('\r');
	RCALL SUBOPT_0x1E
; 0000 0173     delay_ms(500);
	RCALL SUBOPT_0x10
; 0000 0174     }
	RJMP _0x2020006
; .FEND
;//-------------------------------------------------------------
;//------------- SMS------------------------------------
;//-------------------------------------------------------------
;void sms_out (void)                                 //  SMS
; 0000 0179     {
_sms_out:
; .FSTART _sms_out
; 0000 017A     PORTC.3 = 1;                                    //   SMS
	SBI  0x15,3
; 0000 017B     _Temper();                                      //       ( )
	RCALL __Temper
; 0000 017C 
; 0000 017D     for(z=0;cmd_1[z]!='';z++)                       //     
	RCALL SUBOPT_0x19
_0x7B:
	RCALL SUBOPT_0x26
	RCALL SUBOPT_0x1B
	BREQ _0x7C
; 0000 017E         {
; 0000 017F         UDR = cmd_1[z];
	RCALL SUBOPT_0x26
	RCALL SUBOPT_0x1C
; 0000 0180         delay_ms(100);
; 0000 0181         }
	RCALL SUBOPT_0x1D
	RJMP _0x7B
_0x7C:
; 0000 0182     UDR = ('\r');                                   //   ()
	RCALL SUBOPT_0x1E
; 0000 0183     delay_ms(500);
	RCALL SUBOPT_0x10
; 0000 0184     for(z=0;cmd_2[z]!='';z++)                       //  SMS  
	RCALL SUBOPT_0x19
_0x7E:
	RCALL SUBOPT_0x29
	RCALL SUBOPT_0x1B
	BREQ _0x7F
; 0000 0185         {
; 0000 0186         UDR = cmd_2[z];
	RCALL SUBOPT_0x29
	RCALL SUBOPT_0x1C
; 0000 0187         delay_ms(100);
; 0000 0188         }
	RCALL SUBOPT_0x1D
	RJMP _0x7E
_0x7F:
; 0000 0189     UDR = ('\r');                                   //   ()
	RCALL SUBOPT_0x1E
; 0000 018A     delay_ms(500);
	RCALL SUBOPT_0x10
; 0000 018B 
; 0000 018C     for(z=0;cmd_3[z]!='';z++)                       //  SMS   
	RCALL SUBOPT_0x19
_0x81:
	RCALL SUBOPT_0x2A
	RCALL SUBOPT_0x1B
	BREQ _0x82
; 0000 018D         {
; 0000 018E         UDR = cmd_3[z];
	RCALL SUBOPT_0x2A
	RCALL SUBOPT_0x1C
; 0000 018F         delay_ms(100);
; 0000 0190         }
	RCALL SUBOPT_0x1D
	RJMP _0x81
_0x82:
; 0000 0191     UDR = ('"');
	RCALL SUBOPT_0x2B
; 0000 0192     delay_ms(100);
; 0000 0193     for(z=0;cmd_8[z]!='';z++)                       //   
	RCALL SUBOPT_0x19
_0x84:
	RCALL SUBOPT_0x2C
	CPI  R30,0
	BREQ _0x85
; 0000 0194         {
; 0000 0195         UDR = cmd_8[z];
	RCALL SUBOPT_0x2C
	RCALL SUBOPT_0x2D
; 0000 0196         delay_ms(100);
; 0000 0197         }
	RCALL SUBOPT_0x1D
	RJMP _0x84
_0x85:
; 0000 0198     UDR = ('"');
	RCALL SUBOPT_0x2B
; 0000 0199     delay_ms(100);
; 0000 019A     UDR = ('\r');                                   //   ()
	RCALL SUBOPT_0x1E
; 0000 019B     delay_ms(1000);                                 //      SMS ( )
	RCALL SUBOPT_0x15
; 0000 019C     if (_flag == 0)                                 // SMS - "Temper"
	LDS  R30,__flag
	LDS  R31,__flag+1
	SBIW R30,0
	BRNE _0x86
; 0000 019D         {
; 0000 019E 
; 0000 019F         for(z=0;cmd_5[z]!='';z++)                   //   SMS
	RCALL SUBOPT_0x19
_0x88:
	RCALL SUBOPT_0x2E
	RCALL SUBOPT_0x1B
	BREQ _0x89
; 0000 01A0             {
; 0000 01A1             UDR = cmd_5[z];
	RCALL SUBOPT_0x2E
	RCALL SUBOPT_0x1C
; 0000 01A2             delay_ms(100);
; 0000 01A3             }
	RCALL SUBOPT_0x1D
	RJMP _0x88
_0x89:
; 0000 01A4         }
; 0000 01A5     if (_flag == 1)                                 // SMS - "Zvonok"
_0x86:
	RCALL SUBOPT_0x2F
	SBIW R26,1
	BRNE _0x8A
; 0000 01A6         {
; 0000 01A7 
; 0000 01A8         for(z=0;cmd_6[z]!='';z++)                   //   SMS
	RCALL SUBOPT_0x19
_0x8C:
	RCALL SUBOPT_0x30
	RCALL SUBOPT_0x1B
	BREQ _0x8D
; 0000 01A9             {
; 0000 01AA             UDR = cmd_6[z];
	RCALL SUBOPT_0x30
	RCALL SUBOPT_0x1C
; 0000 01AB             delay_ms(100);
; 0000 01AC             }
	RCALL SUBOPT_0x1D
	RJMP _0x8C
_0x8D:
; 0000 01AD         }
; 0000 01AE     if (_flag == 2)
_0x8A:
	RCALL SUBOPT_0x2F
	SBIW R26,2
	BRNE _0x8E
; 0000 01AF         {                                           // SMS - "Brelok"
; 0000 01B0         for(z=0;cmd_7[z]!='';z++)                   //   SMS
	RCALL SUBOPT_0x19
_0x90:
	RCALL SUBOPT_0x31
	RCALL SUBOPT_0x1B
	BREQ _0x91
; 0000 01B1             {
; 0000 01B2             UDR = cmd_7[z];
	RCALL SUBOPT_0x31
	RCALL SUBOPT_0x1C
; 0000 01B3             delay_ms(100);
; 0000 01B4             }
	RCALL SUBOPT_0x1D
	RJMP _0x90
_0x91:
; 0000 01B5         }
; 0000 01B6     if (_flag == 3)
_0x8E:
	RCALL SUBOPT_0x2F
	SBIW R26,3
	BRNE _0x92
; 0000 01B7         {                                           // SMS - "Clear Tel"          
; 0000 01B8         for(z=0;cmd_11[z]!='';z++)                  //   SMS
	RCALL SUBOPT_0x19
_0x94:
	RCALL SUBOPT_0x32
	RCALL SUBOPT_0x1B
	BREQ _0x95
; 0000 01B9             {
; 0000 01BA             UDR = cmd_11[z];
	RCALL SUBOPT_0x32
	RCALL SUBOPT_0x1C
; 0000 01BB             delay_ms(100);
; 0000 01BC             }
	RCALL SUBOPT_0x1D
	RJMP _0x94
_0x95:
; 0000 01BD         }
; 0000 01BE     if (_flag == 4)
_0x92:
	RCALL SUBOPT_0x2F
	SBIW R26,4
	BRNE _0x96
; 0000 01BF         {                                           // SMS - "New Tel"             
; 0000 01C0         for(z=0;cmd_12[z]!='';z++)                  //   SMS
	RCALL SUBOPT_0x19
_0x98:
	RCALL SUBOPT_0x33
	RCALL SUBOPT_0x1B
	BREQ _0x99
; 0000 01C1             {
; 0000 01C2             UDR = cmd_12[z];
	RCALL SUBOPT_0x33
	RCALL SUBOPT_0x1C
; 0000 01C3             delay_ms(100);
; 0000 01C4             }
	RCALL SUBOPT_0x1D
	RJMP _0x98
_0x99:
; 0000 01C5         }
; 0000 01C6     if ((_flag<3)&(devices!=0))                         //  SMS   (, , )    ...
_0x96:
	RCALL SUBOPT_0x2F
	LDI  R30,LOW(3)
	LDI  R31,HIGH(3)
	RCALL __LTW12
	MOV  R0,R30
	MOV  R26,R5
	LDI  R30,LOW(0)
	RCALL __NEB12
	AND  R30,R0
	BREQ _0x9A
; 0000 01C7         {
; 0000 01C8         for(z=0;cmd_14[z]!='';z++)                      //   SMS   " Tem "
	RCALL SUBOPT_0x19
_0x9C:
	RCALL SUBOPT_0x34
	RCALL SUBOPT_0x1B
	BREQ _0x9D
; 0000 01C9             {
; 0000 01CA             UDR = cmd_14[z];
	RCALL SUBOPT_0x34
	RCALL SUBOPT_0x1C
; 0000 01CB             delay_ms(100);
; 0000 01CC             }
	RCALL SUBOPT_0x1D
	RJMP _0x9C
_0x9D:
; 0000 01CD         UDR = (Dt);                                      //      
	LDS  R30,_Dt
	RCALL SUBOPT_0x2D
; 0000 01CE         delay_ms(100);
; 0000 01CF         UDR = (Ct);
	LDS  R30,_Ct
	RCALL SUBOPT_0x2D
; 0000 01D0         delay_ms(100);
; 0000 01D1         UDR = (Bt);
	LDS  R30,_Bt
	RCALL SUBOPT_0x2D
; 0000 01D2         delay_ms(100);
; 0000 01D3         UDR = (',');
	LDI  R30,LOW(44)
	RCALL SUBOPT_0x2D
; 0000 01D4         delay_ms(100);
; 0000 01D5         UDR = (At);
	OUT  0xC,R4
; 0000 01D6         delay_ms(100);
	RCALL SUBOPT_0x24
; 0000 01D7         UDR = ('"');
	RCALL SUBOPT_0x2B
; 0000 01D8         delay_ms(100);
; 0000 01D9         UDR = ('C');
	LDI  R30,LOW(67)
	RCALL SUBOPT_0x2D
; 0000 01DA         delay_ms(100);
; 0000 01DB         }
; 0000 01DC     UDR = (26);                                     // ctrlZ->      0x1A
_0x9A:
	LDI  R30,LOW(26)
	OUT  0xC,R30
; 0000 01DD     delay_ms(1500);
	LDI  R26,LOW(1500)
	LDI  R27,HIGH(1500)
	RCALL _delay_ms
; 0000 01DE //    for(z=0;cmd_2_[z]!='';z++)                      //   
; 0000 01DF //        {
; 0000 01E0 //        UDR = cmd_2_[z];
; 0000 01E1 //        delay_ms(100);
; 0000 01E2 //        }
; 0000 01E3 //    UDR = ('\r');                                   //   ()
; 0000 01E4 //    delay_ms(500);
; 0000 01E5 
; 0000 01E6 
; 0000 01E7 //    Dell_SMS();
; 0000 01E8 
; 0000 01E9     for(z=0;cmd_2_[z]!='';z++)                      //   
	RCALL SUBOPT_0x19
_0x9F:
	RCALL SUBOPT_0x35
	RCALL SUBOPT_0x1B
	BREQ _0xA0
; 0000 01EA         {
; 0000 01EB         UDR = cmd_2_[z];
	RCALL SUBOPT_0x35
	RCALL SUBOPT_0x1C
; 0000 01EC         delay_ms(100);
; 0000 01ED         }
	RCALL SUBOPT_0x1D
	RJMP _0x9F
_0xA0:
; 0000 01EE     UDR = ('\r');                                   //   ()
	RCALL SUBOPT_0x1E
; 0000 01EF     delay_ms(500);
	RCALL SUBOPT_0x10
; 0000 01F0     if (_flag==1)    PORTC.3 = 1;                   //     SMS     
	RCALL SUBOPT_0x2F
	SBIW R26,1
	BRNE _0xA1
	SBI  0x15,3
; 0000 01F1     else PORTC.3 = 0;
	RJMP _0xA4
_0xA1:
	CBI  0x15,3
; 0000 01F2     }
_0xA4:
	RET
; .FEND
;//-------------------------------------------------------------
;//-------------  -------------------------------
;//-------------------------------------------------------------
;void Zvonok(void)
; 0000 01F7     {  int r;
_Zvonok:
; .FSTART _Zvonok
; 0000 01F8     PORTC.3 = 1;                                    //   SMS
	RCALL __SAVELOCR2
;	r -> R16,R17
	SBI  0x15,3
; 0000 01F9 //#asm("cli")
; 0000 01FA     for(z=0;cmd_1[z]!='';z++)                       //     
	RCALL SUBOPT_0x19
_0xAA:
	RCALL SUBOPT_0x26
	RCALL SUBOPT_0x1B
	BREQ _0xAB
; 0000 01FB         {
; 0000 01FC         UDR = cmd_1[z];
	RCALL SUBOPT_0x26
	RCALL SUBOPT_0x1C
; 0000 01FD         delay_ms(100);
; 0000 01FE         }
	RCALL SUBOPT_0x1D
	RJMP _0xAA
_0xAB:
; 0000 01FF     UDR = ('\r');                                   //   ()
	RCALL SUBOPT_0x1E
; 0000 0200     delay_ms(500);
	RCALL SUBOPT_0x10
; 0000 0201     for(z=0;cmd_2_[z]!='';z++)                      //   
	RCALL SUBOPT_0x19
_0xAD:
	RCALL SUBOPT_0x35
	RCALL SUBOPT_0x1B
	BREQ _0xAE
; 0000 0202         {
; 0000 0203         UDR = cmd_2_[z];
	RCALL SUBOPT_0x35
	RCALL SUBOPT_0x1C
; 0000 0204         delay_ms(100);
; 0000 0205         }
	RCALL SUBOPT_0x1D
	RJMP _0xAD
_0xAE:
; 0000 0206     UDR = ('\r');                                   //   ()
	RCALL SUBOPT_0x1E
; 0000 0207     delay_ms(500);
	RCALL SUBOPT_0x10
; 0000 0208 
; 0000 0209     for(z=0;cmd_10[z]!='';z++)                      //     
	RCALL SUBOPT_0x19
_0xB0:
	RCALL SUBOPT_0x36
	RCALL SUBOPT_0x1B
	BREQ _0xB1
; 0000 020A         {
; 0000 020B         UDR = cmd_10[z];
	RCALL SUBOPT_0x36
	RCALL SUBOPT_0x1C
; 0000 020C         delay_ms(100);
; 0000 020D         }
	RCALL SUBOPT_0x1D
	RJMP _0xB0
_0xB1:
; 0000 020E 
; 0000 020F     for(z=0;cmd_8[z]!='';z++)                       //   
	RCALL SUBOPT_0x19
_0xB3:
	RCALL SUBOPT_0x2C
	CPI  R30,0
	BREQ _0xB4
; 0000 0210         {
; 0000 0211         UDR = cmd_8[z];
	RCALL SUBOPT_0x2C
	RCALL SUBOPT_0x2D
; 0000 0212         delay_ms(100);
; 0000 0213         }
	RCALL SUBOPT_0x1D
	RJMP _0xB3
_0xB4:
; 0000 0214     UDR = (';');
	LDI  R30,LOW(59)
	RCALL SUBOPT_0x2D
; 0000 0215     delay_ms(100);
; 0000 0216     UDR = ('\r');                                   //   ()
	RCALL SUBOPT_0x1E
; 0000 0217     delay_ms(1000);                                 //   ( )
	RCALL SUBOPT_0x15
; 0000 0218 
; 0000 0219     for (r=0;r<100;r++)
	RCALL SUBOPT_0x1F
_0xB6:
	__CPWRN 16,17,100
	BRGE _0xB7
; 0000 021A         {
; 0000 021B         delay_ms (150);                             //   15 
	LDI  R26,LOW(150)
	RCALL SUBOPT_0x37
; 0000 021C         if (PINC.4==1)  {r=3000; _Err_out=1;}       //    -  
	SBIC 0x13,4
	RCALL SUBOPT_0x38
; 0000 021D         if (PIND.3==1)  {r=3000; _Err_out=1;}       //    -  
	SBIC 0x10,3
	RCALL SUBOPT_0x38
; 0000 021E         if (PIND.5==0)  {r=3000; _Err_out=1; _Blokir = 1;}   //     (  )
	SBIC 0x10,5
	RJMP _0xBA
	RCALL SUBOPT_0x38
	RCALL SUBOPT_0x39
; 0000 021F         }
_0xBA:
	RCALL SUBOPT_0x25
	RJMP _0xB6
_0xB7:
; 0000 0220 
; 0000 0221     Otboy();                                        //   (  )
	RCALL _Otboy
; 0000 0222 
; 0000 0223     if (_flag==1)    PORTC.3 = 1;                   //     SMS     
	RCALL SUBOPT_0x2F
	SBIW R26,1
	BRNE _0xBB
	SBI  0x15,3
; 0000 0224     else PORTC.3 = 0;
	RJMP _0xBE
_0xBB:
	CBI  0x15,3
; 0000 0225     }
_0xBE:
_0x2020006:
	LD   R16,Y+
	LD   R17,Y+
	RET
; .FEND
;//-------------------------------------------------------------
;//------------- --------------------------------
;//-------------------------------------------------------------
;void Zapusk(void)
; 0000 022A     { unsigned int k; int t=0; int r=0;
_Zapusk:
; .FSTART _Zapusk
; 0000 022B     _Err_out=0;                                     //  
	RCALL __SAVELOCR6
;	k -> R16,R17
;	t -> R18,R19
;	r -> R20,R21
	__GETWRN 18,19,0
	__GETWRN 20,21,0
	RCALL SUBOPT_0x3A
; 0000 022C     if (_Err<2) PORTB.0 = 1;                        //     2  
	RCALL SUBOPT_0x3B
	BRGE _0xC1
	SBI  0x18,0
; 0000 022D     for (t=0;t<20;t++)
_0xC1:
	__GETWRN 18,19,0
_0xC5:
	__CPWRN 18,19,20
	BRGE _0xC6
; 0000 022E         {
; 0000 022F         delay_ms (100);
	RCALL SUBOPT_0x24
; 0000 0230         if (PINC.4==1) {t=30; _Err_out=1;}
	SBIC 0x13,4
	RCALL SUBOPT_0x3C
; 0000 0231         if (PIND.3==1) {t=30; _Err_out=1;}
	SBIC 0x10,3
	RCALL SUBOPT_0x3C
; 0000 0232         }
	__ADDWRN 18,19,1
	RJMP _0xC5
_0xC6:
; 0000 0233     if ((_Err<2)&&(_Err_out==0))
	RCALL SUBOPT_0x3B
	BRGE _0xCA
	RCALL SUBOPT_0x3D
	SBIW R26,0
	BREQ _0xCB
_0xCA:
	RJMP _0xC9
_0xCB:
; 0000 0234       for (k=0;k<42000;k++)                         //  7   
	RCALL SUBOPT_0x1F
_0xCD:
	__CPWRN 16,17,-23536
	BRLO PC+2
	RJMP _0xCE
; 0000 0235         {
; 0000 0236         #asm("wdr");                                //   
	wdr
; 0000 0237         if (_Err>1) {k=50000; _Err_out=1; _Blokir = 1;}     //  2    -   
	RCALL SUBOPT_0x3B
	BRLT _0xCF
	RCALL SUBOPT_0x3E
	RCALL SUBOPT_0x39
; 0000 0238         if (PINC.4==1) {k=50000; _Err_out=1;}       //   -  
_0xCF:
	SBIC 0x13,4
	RCALL SUBOPT_0x3E
; 0000 0239         if (PIND.3==1) {k=50000; _Err_out=1;}       //   -  
	SBIC 0x10,3
	RCALL SUBOPT_0x3E
; 0000 023A         if ((PIND.5==0)&&(_Err<2))                  //    -      2   =  ...
	SBIC 0x10,5
	RJMP _0xD3
	RCALL SUBOPT_0x3B
	BRLT _0xD4
_0xD3:
	RJMP _0xD2
_0xD4:
; 0000 023B             { int f;
; 0000 023C             r++;                                    //   
	SBIW R28,2
;	f -> Y+0
	__ADDWRN 20,21,1
; 0000 023D             if (r>2) {k=50000; _Err_out=1;}         //     (  )-  2 
	__CPWRN 20,21,3
	BRLT _0xD5
	RCALL SUBOPT_0x3E
; 0000 023E             for (f=0;f<402;f++)                     // 4   
_0xD5:
	LDI  R30,LOW(0)
	STD  Y+0,R30
	STD  Y+0+1,R30
_0xD7:
	LD   R26,Y
	LDD  R27,Y+1
	CPI  R26,LOW(0x192)
	LDI  R30,HIGH(0x192)
	CPC  R27,R30
	BRLT PC+2
	RJMP _0xD8
; 0000 023F                 {
; 0000 0240                 if ((PIND.3==0)&&(PINC.4==0))       //    
	SBIC 0x10,3
	RJMP _0xDA
	SBIS 0x13,4
	RJMP _0xDB
_0xDA:
	RJMP _0xD9
_0xDB:
; 0000 0241                     {
; 0000 0242                     if (k<42000) PORTB.1 = 1;       //    7  (  )   
	__CPWRN 16,17,-23536
	BRSH _0xDC
	SBI  0x18,1
; 0000 0243                     else
	RJMP _0xDF
_0xDC:
; 0000 0244                         {
; 0000 0245                         PORTB.1 = 0;                //  
	RCALL SUBOPT_0x3F
; 0000 0246                         PORTB.0 = 0;                //  
; 0000 0247                         k=50000;                    //      7 
; 0000 0248                         f=410;                      //       4 
; 0000 0249                         }
_0xDF:
; 0000 024A                     }
; 0000 024B                 else                                //            ...
	RJMP _0xE4
_0xD9:
; 0000 024C                     {
; 0000 024D                     PORTB.1 = 0;                    //  
	RCALL SUBOPT_0x3F
; 0000 024E                     PORTB.0 = 0;                    //  
; 0000 024F                     k=50000;                        //      7 
; 0000 0250                     f=410;                          //       4 
; 0000 0251                     }
_0xE4:
; 0000 0252                 if (f>400)
	LD   R26,Y
	LDD  R27,Y+1
	CPI  R26,LOW(0x191)
	LDI  R30,HIGH(0x191)
	CPC  R27,R30
	BRLT _0xE9
; 0000 0253                     {
; 0000 0254                     PORTB.1 = 0;                    //  
	CBI  0x18,1
; 0000 0255                     _Err++;                         //     -  
	LDI  R26,LOW(__Err)
	LDI  R27,HIGH(__Err)
	RCALL SUBOPT_0x1
; 0000 0256                     if (_Err>1) f=410;              //   2 (  )   
	RCALL SUBOPT_0x3B
	BRLT _0xEC
	RCALL SUBOPT_0x40
; 0000 0257                     else f=0;
	RJMP _0xED
_0xEC:
	LDI  R30,LOW(0)
	STD  Y+0,R30
	STD  Y+0+1,R30
; 0000 0258                     for (t=0;t<60;t++)
_0xED:
	__GETWRN 18,19,0
_0xEF:
	__CPWRN 18,19,60
	BRGE _0xF0
; 0000 0259                         {
; 0000 025A                         delay_ms (100);             //    6 
	RCALL SUBOPT_0x24
; 0000 025B                         if (PINC.4==1) {t=70; _Err_out=1;}      //  
	SBIC 0x13,4
	RCALL SUBOPT_0x41
; 0000 025C                         if (PIND.3==1) {t=70; _Err_out=1;}      //   
	SBIC 0x10,3
	RCALL SUBOPT_0x41
; 0000 025D                         if (Ring==4)                //   
	RCALL SUBOPT_0x3
	SBIW R26,4
	BRNE _0xF3
; 0000 025E                             {
; 0000 025F                             Ring=0;                 //   
	RCALL SUBOPT_0x6
; 0000 0260                             _Tel = AON_();          //      
	RCALL SUBOPT_0x42
; 0000 0261                             Otboy();                //   ( )
; 0000 0262                             if (_Tel==1)
	BRNE _0xF4
; 0000 0263                                 {
; 0000 0264                                 t=70;
	RCALL SUBOPT_0x41
; 0000 0265                                 _Err_out=1;
; 0000 0266                                 }
; 0000 0267                             }
_0xF4:
; 0000 0268                         }
_0xF3:
	__ADDWRN 18,19,1
	RJMP _0xEF
_0xF0:
; 0000 0269                     }
; 0000 026A                 if (PIND.5==1)                      //   ,  () 
_0xE9:
	SBIS 0x10,5
	RJMP _0xF5
; 0000 026B                   {
; 0000 026C                     f=410;
	RCALL SUBOPT_0x40
; 0000 026D                     PORTB.1 = 0;                    //  
	CBI  0x18,1
; 0000 026E                     _Err_out = 0;                   //   -   
	RCALL SUBOPT_0x3A
; 0000 026F                     _Err = 0;                       //   -  -   
	RCALL SUBOPT_0x43
; 0000 0270 
; 0000 0271                     if (_Tel_SMS==0) sms_out();       //  SMS ( )
	LDS  R30,__Tel_SMS
	CPI  R30,0
	BRNE _0xF8
	RCALL _sms_out
; 0000 0272                     else Zvonok();                  //    15  ( )
	RJMP _0xF9
_0xF8:
	RCALL _Zvonok
; 0000 0273                     if (_Err_out>0)
_0xF9:
	RCALL SUBOPT_0x3D
	RCALL __CPW02
	BRGE _0xFA
; 0000 0274                         {
; 0000 0275                         k=50000;                    //     (   )  _Err++;
	__GETWRN 16,17,-15536
; 0000 0276                         _Err_out = 0;
	RCALL SUBOPT_0x3A
; 0000 0277                         }                           //   -   
; 0000 0278                     else
	RJMP _0xFB
_0xFA:
; 0000 0279                         {
; 0000 027A                         _Err = 0;
	RCALL SUBOPT_0x43
; 0000 027B                         Temperat = 0;
	RCALL SUBOPT_0x44
; 0000 027C                         PORTB.2 = 1;                //  
	SBI  0x18,2
; 0000 027D                         delay_ms (500);
	RCALL SUBOPT_0x10
; 0000 027E                         PORTB.2 = 0;
	CBI  0x18,2
; 0000 027F                         delay_ms (500);
	RCALL SUBOPT_0x10
; 0000 0280                         PORTB.2 = 1;
	SBI  0x18,2
; 0000 0281                         delay_ms (500);
	RCALL SUBOPT_0x10
; 0000 0282                         PORTB.2 = 0;
	CBI  0x18,2
; 0000 0283                         }
_0xFB:
; 0000 0284                   }
; 0000 0285                 delay_ms (10);
_0xF5:
	LDI  R26,LOW(10)
	RCALL SUBOPT_0x37
; 0000 0286                 }
	LD   R30,Y
	LDD  R31,Y+1
	ADIW R30,1
	ST   Y,R30
	STD  Y+1,R31
	RJMP _0xD7
_0xD8:
; 0000 0287             }
	ADIW R28,2
; 0000 0288         if (Ring==4)                                // ----   ( ) ----
_0xD2:
	RCALL SUBOPT_0x3
	SBIW R26,4
	BRNE _0x104
; 0000 0289                 {
; 0000 028A                 Ring=0;                             //   
	RCALL SUBOPT_0x6
; 0000 028B                 _Tel = AON_();                      //      
	RCALL SUBOPT_0x42
; 0000 028C                 Otboy();                            //   ( )
; 0000 028D                 if (_Tel==1)
	BRNE _0x105
; 0000 028E                     {
; 0000 028F                     _Err_out=1;
	RCALL SUBOPT_0x4
	STS  __Err_out,R30
	STS  __Err_out+1,R31
; 0000 0290                     k=50000;
	__GETWRN 16,17,-15536
; 0000 0291 
; 0000 0292                     delay_ms (500);                 //   
	RCALL SUBOPT_0x10
; 0000 0293                     }
; 0000 0294                 }
_0x105:
; 0000 0295         delay_ms (10);
_0x104:
	LDI  R26,LOW(10)
	RCALL SUBOPT_0x37
; 0000 0296         }
	RCALL SUBOPT_0x25
	RJMP _0xCD
_0xCE:
; 0000 0297     PORTB.0 = 0;                                    //  
_0xC9:
	CBI  0x18,0
; 0000 0298     PORTB.1 = 0;                                    //      
	CBI  0x18,1
; 0000 0299     PORTC= (1<<PORTC5) | (1<<PORTC4) | (0<<PORTC3) | (0<<PORTC2) | (0<<PORTC1) | (0<<PORTC0); // Led -   ...
	LDI  R30,LOW(48)
	OUT  0x15,R30
; 0000 029A  //   PORTC.4 = 1;
; 0000 029B     Temperat=0;                                     //    
	RCALL SUBOPT_0x44
; 0000 029C //    #asm("sei")                                   //  
; 0000 029D     }
	RCALL __LOADLOCR6
	RJMP _0x2020004
; .FEND
;//-------------------------------------------------------------------------------------
;//----      (   5   5 ) ----
;//-------------------------------------------------------------------------------------
;void Priviazka_tel(void)                            //      (   5   ...
; 0000 02A2     {  char Ring2, y, x =0;
_Priviazka_tel:
; .FSTART _Priviazka_tel
; 0000 02A3     if (cmd_8e[0]=='+')                             //     (    +)   SMS   ...
	RCALL __SAVELOCR4
;	Ring2 -> R17
;	y -> R16
;	x -> R19
	LDI  R19,0
	LDI  R26,LOW(_cmd_8e)
	LDI  R27,HIGH(_cmd_8e)
	RCALL __EEPROMRDB
	CPI  R30,LOW(0x2B)
	BRNE _0x10A
; 0000 02A4         {
; 0000 02A5         _flag = 3;                                  //  SMS "Clear Tel"
	LDI  R30,LOW(3)
	LDI  R31,HIGH(3)
	RCALL SUBOPT_0x45
; 0000 02A6         sms_out();                                  //  SMS   
	RCALL _sms_out
; 0000 02A7         cmd_8[0]=cmd_8e[0]=0;                       //  +    (  )
	LDI  R26,LOW(_cmd_8e)
	LDI  R27,HIGH(_cmd_8e)
	LDI  R30,LOW(0)
	RCALL __EEPROMWRB
	STS  _cmd_8,R30
; 0000 02A8         }
; 0000 02A9     PORTC.2 = 1;                                    // Led    
_0x10A:
	SBI  0x15,2
; 0000 02AA     if (Ring==4)                                    //  
	RCALL SUBOPT_0x3
	SBIW R26,4
	BREQ PC+2
	RJMP _0x10D
; 0000 02AB         {
; 0000 02AC         PORTC.1 = 1;                                // Led    
	SBI  0x15,1
; 0000 02AD         delay_ms (1000);
	RCALL SUBOPT_0x15
; 0000 02AE         Ring=0;                                     //   
	RCALL SUBOPT_0x6
; 0000 02AF         Otboy();                                    //  
	RCALL _Otboy
; 0000 02B0         if (i==0) return;                           //     - 
	LDS  R30,_i
	CPI  R30,0
	BRNE _0x110
	RJMP _0x2020005
; 0000 02B1         x=i;
_0x110:
	LDS  R19,_i
; 0000 02B2         #asm("cli")                                 //  
	cli
; 0000 02B3         i = 0;                                      //   UART 
	LDI  R30,LOW(0)
	RCALL SUBOPT_0xB
; 0000 02B4 
; 0000 02B5         for ( rx_cursor=0;rx_cursor!=x;rx_cursor++)
	RCALL SUBOPT_0x14
_0x112:
	LDS  R26,_rx_cursor
	CP   R19,R26
	BRNE PC+2
	RJMP _0x113
; 0000 02B6             { PORTC.2 = 1;
	SBI  0x15,2
; 0000 02B7             y = MyBuffer[rx_cursor];
	RCALL SUBOPT_0x17
	RCALL SUBOPT_0xA
	LD   R16,Z
; 0000 02B8             if (y=='R') Ring2=1;
	CPI  R16,82
	BRNE _0x116
	LDI  R17,LOW(1)
; 0000 02B9             if (y=='I')
_0x116:
	CPI  R16,73
	BRNE _0x117
; 0000 02BA                 {
; 0000 02BB                 if (Ring2==1) Ring2++;
	CPI  R17,1
	BRNE _0x118
	SUBI R17,-1
; 0000 02BC                 else  Ring2=0;
	RJMP _0x119
_0x118:
	LDI  R17,LOW(0)
; 0000 02BD                 }
_0x119:
; 0000 02BE             if (y=='N')
_0x117:
	CPI  R16,78
	BRNE _0x11A
; 0000 02BF                 {
; 0000 02C0                 if (Ring2==2) Ring2++;
	CPI  R17,2
	BRNE _0x11B
	SUBI R17,-1
; 0000 02C1                 else  Ring2=0;
	RJMP _0x11C
_0x11B:
	LDI  R17,LOW(0)
; 0000 02C2                 }
_0x11C:
; 0000 02C3             if (y=='G')
_0x11A:
	CPI  R16,71
	BRNE _0x11D
; 0000 02C4                 {
; 0000 02C5                 if (Ring2==3) Ring2++;              // Ring = 4   
	CPI  R17,3
	BRNE _0x11E
	SUBI R17,-1
; 0000 02C6                 else  Ring2=0;
	RJMP _0x11F
_0x11E:
	LDI  R17,LOW(0)
; 0000 02C7                 }
_0x11F:
; 0000 02C8             if (Ring2==4)
_0x11D:
	CPI  R17,4
	BRNE _0x120
; 0000 02C9                 {
; 0000 02CA                 rx_cursor=rx_cursor+13;             //  RING   13     
	RCALL SUBOPT_0x17
	SUBI R30,-LOW(13)
	STS  _rx_cursor,R30
; 0000 02CB                 for (z=0;z<13;z++)
	RCALL SUBOPT_0x19
_0x122:
	RCALL SUBOPT_0x46
	SBIW R26,13
	BRSH _0x123
; 0000 02CC                     {
; 0000 02CD                     cmd_8[z] = cmd_8e[z] = MyBuffer[rx_cursor];      //       EEProm   ...
	RCALL SUBOPT_0x47
	RCALL SUBOPT_0x17
	RCALL SUBOPT_0xA
	LD   R30,Z
	RCALL __EEPROMWRB
	MOVW R26,R0
	ST   X,R30
; 0000 02CE                     rx_cursor++;
	RCALL SUBOPT_0x18
; 0000 02CF                     if (z==12)
	RCALL SUBOPT_0x46
	SBIW R26,12
	BRNE _0x124
; 0000 02D0                         {
; 0000 02D1                         cmd_8[z] = cmd_8e[z] = 0;
	RCALL SUBOPT_0x47
	LDI  R30,LOW(0)
	RCALL __EEPROMWRB
	MOVW R26,R0
	ST   X,R30
; 0000 02D2                         _flag = 4;                  //  SMS "New Tel"
	LDI  R30,LOW(4)
	LDI  R31,HIGH(4)
	RCALL SUBOPT_0x45
; 0000 02D3                         delay_ms (1000);
	RCALL SUBOPT_0x15
; 0000 02D4                         sms_out();                  //  SMS   
	RCALL _sms_out
; 0000 02D5                         PORTC.3 = 1;                // Led    
	SBI  0x15,3
; 0000 02D6                         delay_ms (500);
	RCALL SUBOPT_0x10
; 0000 02D7                         PORTC=(1<<PORTC5) | (1<<PORTC4) | (0<<PORTC3) | (0<<PORTC2) | (0<<PORTC1) | (0<<PORTC0);
	LDI  R30,LOW(48)
	OUT  0x15,R30
; 0000 02D8                         #asm("sei")                 //  
	sei
; 0000 02D9                         return;                     //    
	RJMP _0x2020005
; 0000 02DA                         }
; 0000 02DB                     }
_0x124:
	RCALL SUBOPT_0x1D
	RJMP _0x122
_0x123:
; 0000 02DC                 }
; 0000 02DD             }
_0x120:
	RCALL SUBOPT_0x18
	RJMP _0x112
_0x113:
; 0000 02DE         }
; 0000 02DF     }
_0x10D:
_0x2020005:
	RCALL __LOADLOCR4
	ADIW R28,4
	RET
; .FEND
;
;//=====================================================================
;void main(void)
; 0000 02E3 {
_main:
; .FSTART _main
; 0000 02E4 // Declare your local variables here
; 0000 02E5 //-----------------------
; 0000 02E6 // Watchdog Timer initialization
; 0000 02E7 // Watchdog Timer Prescaler: OSC/2048k
; 0000 02E8 #pragma optsize-
; 0000 02E9 //WDTCR=0x1F;                // OSC/2048k
; 0000 02EA //WDTCR=0x0F;                // 1   2 
; 0000 02EB WDTCR = (1<<WDCE) | (1<<WDE) | (1<<WDP2) | (1<<WDP1) | (1<<WDP0);   // OSC/2048k
	LDI  R30,LOW(31)
	OUT  0x21,R30
; 0000 02EC WDTCR = (0<<WDCE) | (1<<WDE) | (1<<WDP2) | (1<<WDP1) | (1<<WDP0);   // 1   2 
	LDI  R30,LOW(15)
	OUT  0x21,R30
; 0000 02ED 
; 0000 02EE // WDTCR = (1<<WDCE) | (1<<WDE) | (1<<WDP2) | (1<<WDP1) | (0<<WDP0);   // OSC/1024k
; 0000 02EF // WDTCR = (0<<WDCE) | (1<<WDE) | (1<<WDP2) | (1<<WDP1) | (0<<WDP0);   // 1   1 
; 0000 02F0 
; 0000 02F1 //-----------------------
; 0000 02F2 // Input/Output Ports initialization
; 0000 02F3 // Port B initialization
; 0000 02F4 // Function: Bit7=In Bit6=In Bit5=Out Bit4=Out Bit3=Out Bit2=Out Bit1=Out Bit0=Out
; 0000 02F5 DDRB=(0<<DDB7) | (0<<DDB6) | (1<<DDB5) | (1<<DDB4) | (1<<DDB3) | (1<<DDB2) | (1<<DDB1) | (1<<DDB0);
	LDI  R30,LOW(63)
	OUT  0x17,R30
; 0000 02F6 // State: Bit7=T Bit6=T Bit5=0 Bit4=0 Bit3=0 Bit2=0 Bit1=0 Bit0=0
; 0000 02F7 PORTB=(0<<PORTB7) | (0<<PORTB6) | (0<<PORTB5) | (0<<PORTB4) | (0<<PORTB3) | (0<<PORTB2) | (0<<PORTB1) | (0<<PORTB0);
	LDI  R30,LOW(0)
	OUT  0x18,R30
; 0000 02F8 
; 0000 02F9 // Port C initialization
; 0000 02FA // Function: Bit6=In Bit5=In Bit4=Out Bit3=Out Bit2=Out Bit1=Out Bit0=In
; 0000 02FB DDRC=(0<<DDC6) | (0<<DDC5) | (0<<DDC4) | (1<<DDC3) | (1<<DDC2) | (1<<DDC1) | (0<<DDC0);
	LDI  R30,LOW(14)
	OUT  0x14,R30
; 0000 02FC // State: Bit6=T Bit5=T Bit4=0 Bit3=0 Bit2=0 Bit1=0 Bit0=T
; 0000 02FD PORTC=(0<<PORTC6) | (1<<PORTC5) | (1<<PORTC4) | (0<<PORTC3) | (0<<PORTC2) | (0<<PORTC1) | (0<<PORTC0);
	LDI  R30,LOW(48)
	OUT  0x15,R30
; 0000 02FE 
; 0000 02FF // Port D initialization
; 0000 0300 // Function: Bit7=In Bit6=In Bit5=In Bit4=In Bit3=In Bit2=In Bit1=In Bit0=In
; 0000 0301 DDRD=(0<<DDD7) | (0<<DDD6) | (0<<DDD5) | (0<<DDD4) | (0<<DDD3) | (0<<DDD2) | (0<<DDD1) | (0<<DDD0);
	LDI  R30,LOW(0)
	OUT  0x11,R30
; 0000 0302 // State: Bit7=T Bit6=T Bit5=T Bit4=T Bit3=T Bit2=T Bit1=T Bit0=T
; 0000 0303 PORTD=(0<<PORTD7) | (0<<PORTD6) | (1<<PORTD5) | (1<<PORTD4) | (1<<PORTD3) | (1<<PORTD2) | (0<<PORTD1) | (0<<PORTD0);
	LDI  R30,LOW(60)
	OUT  0x12,R30
; 0000 0304 //------------------------------
; 0000 0305 // Timer/Counter 0 initialization
; 0000 0306 // Clock source: System Clock
; 0000 0307 // Clock value: Timer 0 Stopped
; 0000 0308 TCCR0=(0<<CS02) | (0<<CS01) | (0<<CS00);
	LDI  R30,LOW(0)
	OUT  0x33,R30
; 0000 0309 TCNT0=0x00;
	OUT  0x32,R30
; 0000 030A 
; 0000 030B // Timer/Counter 1 initialization
; 0000 030C // Clock source: System Clock
; 0000 030D // Clock value: 3,906 kHz
; 0000 030E // Mode: Normal top=0xFFFF
; 0000 030F // OC1A output: Discon.
; 0000 0310 // OC1B output: Discon.
; 0000 0311 // Noise Canceler: Off
; 0000 0312 // Input Capture on Falling Edge
; 0000 0313 // Timer1 Overflow Interrupt: On
; 0000 0314 // Input Capture Interrupt: Off
; 0000 0315 // Compare A Match Interrupt: Off
; 0000 0316 // Compare B Match Interrupt: Off
; 0000 0317 TCCR1A=0x00;
	OUT  0x2F,R30
; 0000 0318 TCCR1B=0x05;
	LDI  R30,LOW(5)
	OUT  0x2E,R30
; 0000 0319 TCNT1H=0x00;
	LDI  R30,LOW(0)
	OUT  0x2D,R30
; 0000 031A TCNT1L=0x00;
	OUT  0x2C,R30
; 0000 031B ICR1H=0x00;
	OUT  0x27,R30
; 0000 031C ICR1L=0x00;
	OUT  0x26,R30
; 0000 031D OCR1AH=0x00;
	OUT  0x2B,R30
; 0000 031E OCR1AL=0x00;
	OUT  0x2A,R30
; 0000 031F OCR1BH=0x00;
	OUT  0x29,R30
; 0000 0320 OCR1BL=0x00;
	OUT  0x28,R30
; 0000 0321 
; 0000 0322 // Timer/Counter 2 initialization
; 0000 0323 // Clock source: System Clock
; 0000 0324 // Clock value: Timer2 Stopped
; 0000 0325 // Mode: Normal top=0xFF
; 0000 0326 // OC2 output: Disconnected
; 0000 0327 ASSR=0<<AS2;
	OUT  0x22,R30
; 0000 0328 TCCR2=(0<<PWM2) | (0<<COM21) | (0<<COM20) | (0<<CTC2) | (0<<CS22) | (0<<CS21) | (0<<CS20);
	OUT  0x25,R30
; 0000 0329 TCNT2=0x00;
	OUT  0x24,R30
; 0000 032A OCR2=0x00;
	OUT  0x23,R30
; 0000 032B 
; 0000 032C // Timer(s)/Counter(s) Interrupt(s) initialization
; 0000 032D //TIMSK=(0<<OCIE2) | (0<<TOIE2) | (0<<TICIE1) | (0<<OCIE1A) | (0<<OCIE1B) | (0<<TOIE1) | (0<<TOIE0);
; 0000 032E // Timer(s)/Counter(s) Interrupt(s) initialization
; 0000 032F TIMSK=0x04;
	LDI  R30,LOW(4)
	OUT  0x39,R30
; 0000 0330 //----------------------------------------
; 0000 0331 // External Interrupt(s) initialization
; 0000 0332 // INT0: Off
; 0000 0333 // INT1: Off
; 0000 0334 MCUCR=(0<<ISC11) | (0<<ISC10) | (0<<ISC01) | (0<<ISC00);
	LDI  R30,LOW(0)
	OUT  0x35,R30
; 0000 0335 //----------------------------------------
; 0000 0336 // USART initialization
; 0000 0337 // Communication Parameters: 8 Data, 1 Stop, No Parity
; 0000 0338 // USART Receiver: On
; 0000 0339 // USART Transmitter: On
; 0000 033A // USART Mode: Asynchronous
; 0000 033B // USART Baud Rate: 9600
; 0000 033C //UCSRA=0x00;
; 0000 033D //UCSRB=0x98;  //0x08;                              //        0x98; // ( )   ...
; 0000 033E //UCSRB=(0<<RXEN)|( 1<<TXEN);                       //      USART
; 0000 033F //UCSRC=0x86;                                       //    AtMega8
; 0000 0340 //UBRRH=0x00;
; 0000 0341 //UBRRL=0x19;
; 0000 0342 
; 0000 0343 // USART initialization
; 0000 0344 // Communication Parameters: 8 Data, 1 Stop, No Parity
; 0000 0345 // USART Receiver: On
; 0000 0346 // USART Transmitter: On
; 0000 0347 // USART Mode: Asynchronous
; 0000 0348 // USART Baud Rate: 9600
; 0000 0349 
; 0000 034A UCSRA=0x00;
	OUT  0xB,R30
; 0000 034B UCSRB=0x98;
	LDI  R30,LOW(152)
	OUT  0xA,R30
; 0000 034C UCSRC=0x86;
	LDI  R30,LOW(134)
	OUT  0x20,R30
; 0000 034D UBRRH=0x00;
	LDI  R30,LOW(0)
	OUT  0x20,R30
; 0000 034E UBRRL=0x19;
	LDI  R30,LOW(25)
	OUT  0x9,R30
; 0000 034F //----------------------
; 0000 0350 // Analog Comparator initialization
; 0000 0351 // Analog Comparator: On
; 0000 0352 // The Analog Comparator's positive input is
; 0000 0353 // connected to the AIN0 pin
; 0000 0354 // The Analog Comparator's negative input is
; 0000 0355 // connected to the AIN1 pin
; 0000 0356 // Interrupt on Rising Output Edge
; 0000 0357 // Analog Comparator Input Capture by Timer/Counter 1: Off
; 0000 0358 ACSR=(0<<ACD) | (0<<ACBG) | (0<<ACO) | (0<<ACI) | (1<<ACIE) | (0<<ACIC) | (1<<ACIS1) | (1<<ACIS0);
	LDI  R30,LOW(11)
	OUT  0x8,R30
; 0000 0359 SFIOR=(0<<ACME);
	LDI  R30,LOW(0)
	OUT  0x30,R30
; 0000 035A 
; 0000 035B // ADC initialization
; 0000 035C // ADC disabled
; 0000 035D ADCSRA=(0<<ADEN) | (0<<ADSC) | (0<<ADFR) | (0<<ADIF) | (0<<ADIE) | (0<<ADPS2) | (0<<ADPS1) | (0<<ADPS0);
	OUT  0x6,R30
; 0000 035E //----------------------------------------
; 0000 035F // SPI initialization
; 0000 0360 // SPI disabled
; 0000 0361 SPCR=(0<<SPIE) | (0<<SPE) | (0<<DORD) | (0<<MSTR) | (0<<CPOL) | (0<<CPHA) | (0<<SPR1) | (0<<SPR0);
	OUT  0xD,R30
; 0000 0362 //----------------------------------------
; 0000 0363 // TWI initialization
; 0000 0364 // TWI disabled
; 0000 0365 TWCR=(0<<TWEA) | (0<<TWSTA) | (0<<TWSTO) | (0<<TWEN) | (0<<TWIE);
	OUT  0x36,R30
; 0000 0366 //========================================
; 0000 0367 if (devices==0)
	TST  R5
	BRNE _0x127
; 0000 0368         {
; 0000 0369         devices=w1_search(DS18B20_SEARCH_ROM_CMD,rom_code);             //        ...
	LDI  R30,LOW(240)
	ST   -Y,R30
	LDI  R26,LOW(_rom_code)
	LDI  R27,HIGH(_rom_code)
	RCALL _w1_search
	MOV  R5,R30
; 0000 036A         ds18b20_init(0,-35,35,DS18B20_12BIT_RES);//DS18B20_12BIT_RES);  //    12  
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(221)
	ST   -Y,R30
	LDI  R30,LOW(35)
	ST   -Y,R30
	LDI  R26,LOW(3)
	RCALL _ds18b20_init
; 0000 036B         delay_ms(500);
	LDI  R26,LOW(500)
	LDI  R27,HIGH(500)
	RCALL _delay_ms
; 0000 036C         }
; 0000 036D _Start_telef();
_0x127:
	RCALL __Start_telef
; 0000 036E #asm("cli")                                         //  
	cli
; 0000 036F i = 0;                                              //   UART 
	LDI  R30,LOW(0)
	STS  _i,R30
; 0000 0370 #asm("sei")                                         //  
	sei
; 0000 0371 if (cmd_8e[0]!='+') Priviazka_tel();                //      (     +)
	LDI  R26,LOW(_cmd_8e)
	LDI  R27,HIGH(_cmd_8e)
	RCALL __EEPROMRDB
	CPI  R30,LOW(0x2B)
	BREQ _0x128
	RCALL _Priviazka_tel
; 0000 0372 for(z=0;z<13;z++)                                   //     EEProm
_0x128:
	LDI  R30,LOW(0)
	STS  _z,R30
	STS  _z+1,R30
_0x12A:
	LDS  R26,_z
	LDS  R27,_z+1
	SBIW R26,13
	BRSH _0x12B
; 0000 0373         {
; 0000 0374         cmd_8[z] = cmd_8e[z];                       //     EEProm  
	LDS  R30,_z
	LDS  R31,_z+1
	SUBI R30,LOW(-_cmd_8)
	SBCI R31,HIGH(-_cmd_8)
	MOVW R0,R30
	LDS  R26,_z
	LDS  R27,_z+1
	SUBI R26,LOW(-_cmd_8e)
	SBCI R27,HIGH(-_cmd_8e)
	RCALL __EEPROMRDB
	MOVW R26,R0
	ST   X,R30
; 0000 0375         }
	LDI  R26,LOW(_z)
	LDI  R27,HIGH(_z)
	LD   R30,X+
	LD   R31,X+
	ADIW R30,1
	ST   -X,R31
	ST   -X,R30
	RJMP _0x12A
_0x12B:
; 0000 0376 _Tel_SMS = _Tel_SMS_E;                              //     SMS  
	LDI  R26,LOW(__Tel_SMS_E)
	LDI  R27,HIGH(__Tel_SMS_E)
	RCALL __EEPROMRDB
	STS  __Tel_SMS,R30
; 0000 0377 if (_Tel_SMS>1) _Tel_SMS_E=_Tel_SMS=0;              //   0  1
	LDS  R26,__Tel_SMS
	CPI  R26,LOW(0x2)
	BRLO _0x12C
	LDI  R30,LOW(0)
	STS  __Tel_SMS,R30
	LDI  R26,LOW(__Tel_SMS_E)
	LDI  R27,HIGH(__Tel_SMS_E)
	RCALL __EEPROMWRB
; 0000 0378 
; 0000 0379 //----------------------------------------------
; 0000 037A // Global enable interrupts
; 0000 037B #asm("sei")
_0x12C:
	sei
; 0000 037C PORTD.2 = 0;
	CBI  0x12,2
; 0000 037D while (1)  //   
_0x12F:
; 0000 037E    {   int t1,t2,t3,t4=0;
; 0000 037F    _Err = 0;                                        //   
	SBIW R28,8
	LDI  R30,LOW(0)
	ST   Y,R30
	STD  Y+1,R30
;	t1 -> Y+6
;	t2 -> Y+4
;	t3 -> Y+2
;	t4 -> Y+0
	STS  __Err,R30
	STS  __Err+1,R30
; 0000 0380 //-----------------------      -----------------
; 0000 0381    if (PIND.5==1)                                   //   
	SBIS 0x10,5
	RJMP _0x132
; 0000 0382      {
; 0000 0383      #asm("cli")
	cli
; 0000 0384 
; 0000 0385      for (;PIND.5==1;)                              //       
_0x134:
	SBIS 0x10,5
	RJMP _0x135
; 0000 0386         {
; 0000 0387         #asm("wdr");                                //   
	wdr
; 0000 0388 
; 0000 0389 
; 0000 038A         PORTB.0 = 0;                                //      (     )
	CBI  0x18,0
; 0000 038B         PORTB.1 = 0;                                //      
	CBI  0x18,1
; 0000 038C         if (PINC.4==1)  PORTB.2 = 1;                //         
	SBIS 0x13,4
	RJMP _0x13A
	SBI  0x18,2
; 0000 038D         else            PORTB.2 = 0;                //   
	RJMP _0x13D
_0x13A:
	CBI  0x18,2
; 0000 038E         if ((PIND.3==1)&(PINC.0==1))               // = Drive      
_0x13D:
	LDI  R26,0
	SBIC 0x10,3
	LDI  R26,1
	LDI  R30,LOW(1)
	RCALL __EQB12
	MOV  R0,R30
	LDI  R26,0
	SBIC 0x13,0
	LDI  R26,1
	LDI  R30,LOW(1)
	RCALL __EQB12
	AND  R30,R0
	BREQ _0x140
; 0000 038F             {
; 0000 0390             PORTC.2 = 1;
	SBI  0x15,2
; 0000 0391             for (;PINC.0==1;) delay_ms (100);       //  
_0x144:
	SBIS 0x13,0
	RJMP _0x145
	LDI  R26,LOW(100)
	LDI  R27,0
	RCALL _delay_ms
	RJMP _0x144
_0x145:
; 0000 0392 for (i=0;i<100;i++)
	LDI  R30,LOW(0)
	STS  _i,R30
_0x147:
	LDS  R26,_i
	CPI  R26,LOW(0x64)
	BRSH _0x148
; 0000 0393                 {
; 0000 0394 
; 0000 0395                 if (PINC.0==1)
	SBIS 0x13,0
	RJMP _0x149
; 0000 0396                     {
; 0000 0397                     if (_Tel_SMS==0) _Tel_SMS_E=_Tel_SMS=1; //     SMS=0  =1
	LDS  R30,__Tel_SMS
	CPI  R30,0
	BRNE _0x14A
	LDI  R30,LOW(1)
	RJMP _0x198
; 0000 0398                     else             _Tel_SMS_E=_Tel_SMS=0;
_0x14A:
	LDI  R30,LOW(0)
_0x198:
	STS  __Tel_SMS,R30
	LDI  R26,LOW(__Tel_SMS_E)
	LDI  R27,HIGH(__Tel_SMS_E)
	RCALL __EEPROMWRB
; 0000 0399                     i=65;
	LDI  R30,LOW(65)
	STS  _i,R30
; 0000 039A                     }
; 0000 039B                 delay_ms (50);
_0x149:
	LDI  R26,LOW(50)
	LDI  R27,0
	RCALL _delay_ms
; 0000 039C                 }
	LDS  R30,_i
	SUBI R30,-LOW(1)
	STS  _i,R30
	RJMP _0x147
_0x148:
; 0000 039D            PORTC.2 = 0;
	CBI  0x15,2
; 0000 039E            _Start_telef();                         //          Sim800L ...
	RCALL __Start_telef
; 0000 039F 
; 0000 03A0            }
; 0000 03A1         }
_0x140:
	RJMP _0x134
_0x135:
; 0000 03A2         _Blokir = 0;                                //      
	LDI  R30,LOW(0)
	STS  __Blokir,R30
	STS  __Blokir+1,R30
; 0000 03A3         Temperat = 0;                               //     (  )
	STS  _Temperat,R30
	STS  _Temperat+1,R30
; 0000 03A4       }
; 0000 03A5       //-----------------------------------------------------
; 0000 03A6    else {
	RJMP _0x14E
_0x132:
; 0000 03A7         #asm("sei")                                           //    (  )
	sei
; 0000 03A8         PORTB.2 = 0;                                //  
	CBI  0x18,2
; 0000 03A9 //---------- ------------------------------------
; 0000 03AA    if (PIND.3==1)                                //          -     ...
	SBIS 0x10,3
	RJMP _0x151
; 0000 03AB      {
; 0000 03AC      if (cmd_8[0]!='+')  Priviazka_tel();        //           +
	LDS  R26,_cmd_8
	CPI  R26,LOW(0x2B)
	BREQ _0x152
	RCALL _Priviazka_tel
; 0000 03AD         if (PINC.4==0)
_0x152:
	SBIC 0x13,4
	RJMP _0x153
; 0000 03AE             {                         //    5    5          ...
; 0000 03AF             for (t1=0;t1<5;t1++)
	LDI  R30,LOW(0)
	STD  Y+6,R30
	STD  Y+6+1,R30
_0x155:
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	SBIW R26,5
	BRGE _0x156
; 0000 03B0                 {
; 0000 03B1                 for (t2=0;t2<40;t2++)
	LDI  R30,LOW(0)
	STD  Y+4,R30
	STD  Y+4+1,R30
_0x158:
	LDD  R26,Y+4
	LDD  R27,Y+4+1
	SBIW R26,40
	BRGE _0x159
; 0000 03B2                     {
; 0000 03B3                     if (PINC.4==0) delay_ms (25);
	SBIC 0x13,4
	RJMP _0x15A
	LDI  R26,LOW(25)
	LDI  R27,0
	RCALL _delay_ms
; 0000 03B4                     else
	RJMP _0x15B
_0x15A:
; 0000 03B5                         {
; 0000 03B6                         for (t3=0;t3<40;t3++)
	LDI  R30,LOW(0)
	STD  Y+2,R30
	STD  Y+2+1,R30
_0x15D:
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	SBIW R26,40
	BRGE _0x15E
; 0000 03B7                             {
; 0000 03B8                             if (PINC.4==1) delay_ms (25);
	SBIS 0x13,4
	RJMP _0x15F
	LDI  R26,LOW(25)
	LDI  R27,0
	RCALL _delay_ms
; 0000 03B9                             else
	RJMP _0x160
_0x15F:
; 0000 03BA                                 {
; 0000 03BB                                 t4++;
	LD   R30,Y
	LDD  R31,Y+1
	ADIW R30,1
	ST   Y,R30
	STD  Y+1,R31
; 0000 03BC                                 t3=t2=41;
	LDI  R30,LOW(41)
	LDI  R31,HIGH(41)
	STD  Y+4,R30
	STD  Y+4+1,R31
	STD  Y+2,R30
	STD  Y+2+1,R31
; 0000 03BD 
; 0000 03BE                                 }
_0x160:
; 0000 03BF                             }
	LDD  R30,Y+2
	LDD  R31,Y+2+1
	ADIW R30,1
	STD  Y+2,R30
	STD  Y+2+1,R31
	RJMP _0x15D
_0x15E:
; 0000 03C0                         }
_0x15B:
; 0000 03C1                     }
	LDD  R30,Y+4
	LDD  R31,Y+4+1
	ADIW R30,1
	STD  Y+4,R30
	STD  Y+4+1,R31
	RJMP _0x158
_0x159:
; 0000 03C2                 }
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	ADIW R30,1
	STD  Y+6,R30
	STD  Y+6+1,R31
	RJMP _0x155
_0x156:
; 0000 03C3             if (t4>4) Priviazka_tel();              //      (   5   ...
	LD   R26,Y
	LDD  R27,Y+1
	SBIW R26,5
	BRLT _0x161
	RCALL _Priviazka_tel
; 0000 03C4             }
_0x161:
; 0000 03C5      }
_0x153:
; 0000 03C6    //------------------------------------------------------
; 0000 03C7         delay_ms (500);
_0x151:
	LDI  R26,LOW(500)
	LDI  R27,HIGH(500)
	RCALL _delay_ms
; 0000 03C8         if ((PINC.4==0)&&(PIND.3==0))               // ====        ====
	SBIC 0x13,4
	RJMP _0x163
	SBIS 0x10,3
	RJMP _0x164
_0x163:
	RJMP _0x162
_0x164:
; 0000 03C9             {                                       //   :
; 0000 03CA //-------------    ----------------------------
; 0000 03CB //            if (PIND.4==1)
; 0000 03CC             if (_tim == _tim_end)                        //    DS18b20   60 
	LDS  R26,__tim
	LDS  R27,__tim+1
	SBIW R26,60
	BRNE _0x165
; 0000 03CD                 {
; 0000 03CE                 _tim = 0;
	LDI  R30,LOW(0)
	STS  __tim,R30
	STS  __tim+1,R30
; 0000 03CF                 PORTC.1 = 1;
	SBI  0x15,1
; 0000 03D0                 _Temper();
	RCALL __Temper
; 0000 03D1                 PORTC.1 = 0;
	CBI  0x15,1
; 0000 03D2                 }
; 0000 03D3             if (Temperat==1)
_0x165:
	LDS  R26,_Temperat
	LDS  R27,_Temperat+1
	SBIW R26,1
	BRNE _0x16A
; 0000 03D4                 {                                   // ----   -17   ----
; 0000 03D5                 if (_Blokir==0)
	LDS  R30,__Blokir
	LDS  R31,__Blokir+1
	SBIW R30,0
	BRNE _0x16B
; 0000 03D6                         {
; 0000 03D7                         _flag = 0;                  //  SMS "Temperat"
	LDI  R30,LOW(0)
	STS  __flag,R30
	STS  __flag+1,R30
; 0000 03D8                         PORTC.1 = 1;                // Led   
	SBI  0x15,1
; 0000 03D9                         Zapusk();
	RCALL _Zapusk
; 0000 03DA                         PORTC.1 = 0;
	CBI  0x15,1
; 0000 03DB                         }
; 0000 03DC                 }
_0x16B:
; 0000 03DD //-------------    ----------------------------
; 0000 03DE             if (Deact==5)                           //     -   "DEACT"
_0x16A:
	LDS  R26,_Deact
	LDS  R27,_Deact+1
	SBIW R26,5
	BRNE _0x170
; 0000 03DF                 {
; 0000 03E0                 Deact=0;
	LDI  R30,LOW(0)
	STS  _Deact,R30
	STS  _Deact+1,R30
; 0000 03E1                 _Start_telef();                     //  Deact==5( )    GPS 
	RCALL __Start_telef
; 0000 03E2                 }
; 0000 03E3             if (Ring==4)                            //  Ring==4( )   ()
_0x170:
	LDS  R26,_Ring
	LDS  R27,_Ring+1
	SBIW R26,4
	BRNE _0x171
; 0000 03E4                 {
; 0000 03E5                 Ring=0;                             //   
	LDI  R30,LOW(0)
	STS  _Ring,R30
	STS  _Ring+1,R30
; 0000 03E6                 if(_Blokir==0)                      // ----      ( ) ----
	LDS  R30,__Blokir
	LDS  R31,__Blokir+1
	SBIW R30,0
	BRNE _0x172
; 0000 03E7                     {
; 0000 03E8                     _Tel = 0;
	LDI  R30,LOW(0)
	STS  __Tel,R30
	STS  __Tel+1,R30
; 0000 03E9                     _Tel = AON_();                  //      
	RCALL _AON_
	STS  __Tel,R30
	STS  __Tel+1,R31
; 0000 03EA                     Otboy();                        //   ( )
	RCALL _Otboy
; 0000 03EB                     if (_Tel==1)                    //  ""    
	LDS  R26,__Tel
	LDS  R27,__Tel+1
	SBIW R26,1
	BRNE _0x173
; 0000 03EC                         {
; 0000 03ED                         PORTC.3 = 1;
	SBI  0x15,3
; 0000 03EE                         _flag = 1;                  //  SMS "Zvonok"
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	STS  __flag,R30
	STS  __flag+1,R31
; 0000 03EF                         Zapusk();
	RCALL _Zapusk
; 0000 03F0                         _Tel = 0;
	LDI  R30,LOW(0)
	STS  __Tel,R30
	STS  __Tel+1,R30
; 0000 03F1                         PORTC.3 = 0;                // Led    Off
	CBI  0x15,3
; 0000 03F2                         }
; 0000 03F3                     }
_0x173:
; 0000 03F4                 }
_0x172:
; 0000 03F5 //-------------    ----------------------------
; 0000 03F6             if (PINC.0==1)                          // ----   ( ) ----
_0x171:
	SBIS 0x13,0
	RJMP _0x178
; 0000 03F7                 { int i=0; int r=0;
; 0000 03F8                 for (;PINC.0==1;) delay_ms (100);   //   
	SBIW R28,4
	LDI  R30,LOW(0)
	ST   Y,R30
	STD  Y+1,R30
	STD  Y+2,R30
	STD  Y+3,R30
;	t1 -> Y+10
;	t2 -> Y+8
;	t3 -> Y+6
;	t4 -> Y+4
;	i -> Y+2
;	r -> Y+0
_0x17A:
	SBIS 0x13,0
	RJMP _0x17B
	LDI  R26,LOW(100)
	LDI  R27,0
	RCALL _delay_ms
	RJMP _0x17A
_0x17B:
; 0000 03FA for (i=0;i<6;i++)
	LDI  R30,LOW(0)
	STD  Y+2,R30
	STD  Y+2+1,R30
_0x17D:
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	SBIW R26,6
	BRGE _0x17E
; 0000 03FB                     {                               //      2  (  )
; 0000 03FC                     if (r==0)
	LD   R30,Y
	LDD  R31,Y+1
	SBIW R30,0
	BRNE _0x17F
; 0000 03FD                         {
; 0000 03FE                         PORTC.2 = 1;
	SBI  0x15,2
; 0000 03FF                         r=1;
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	ST   Y,R30
	STD  Y+1,R31
; 0000 0400                         }
; 0000 0401                     else
	RJMP _0x182
_0x17F:
; 0000 0402                         {
; 0000 0403                         PORTC.2 = 0;
	CBI  0x15,2
; 0000 0404                         r=0;
	LDI  R30,LOW(0)
	STD  Y+0,R30
	STD  Y+0+1,R30
; 0000 0405                         };
_0x182:
; 0000 0406                     delay_ms (330);
	LDI  R26,LOW(330)
	LDI  R27,HIGH(330)
	RCALL _delay_ms
; 0000 0407                     };
	LDD  R30,Y+2
	LDD  R31,Y+2+1
	ADIW R30,1
	STD  Y+2,R30
	STD  Y+2+1,R31
	RJMP _0x17D
_0x17E:
; 0000 0408                 for (i=0;i<20;i++)              //  3     
	LDI  R30,LOW(0)
	STD  Y+2,R30
	STD  Y+2+1,R30
_0x186:
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	SBIW R26,20
	BRGE _0x187
; 0000 0409                     {
; 0000 040A                     #asm("wdr");                //   
	wdr
; 0000 040B                     if (r==0)
	LD   R30,Y
	LDD  R31,Y+1
	SBIW R30,0
	BRNE _0x188
; 0000 040C                         {
; 0000 040D                         PORTC.2 = 1;
	SBI  0x15,2
; 0000 040E                         r=1;
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	ST   Y,R30
	STD  Y+1,R31
; 0000 040F                         }
; 0000 0410                     else
	RJMP _0x18B
_0x188:
; 0000 0411                         {
; 0000 0412                         PORTC.2 = 0;
	CBI  0x15,2
; 0000 0413                         r=0;
	LDI  R30,LOW(0)
	STD  Y+0,R30
	STD  Y+0+1,R30
; 0000 0414                         };
_0x18B:
; 0000 0415                     delay_ms (150);
	LDI  R26,LOW(150)
	LDI  R27,0
	RCALL _delay_ms
; 0000 0416                     if (PINC.0==1)              //        3   
	SBIS 0x13,0
	RJMP _0x18E
; 0000 0417                         {
; 0000 0418                         _flag = 2;              //  SMS "Brelok"
	LDI  R30,LOW(2)
	LDI  R31,HIGH(2)
	STS  __flag,R30
	STS  __flag+1,R31
; 0000 0419                         for (;PINC.0==1;) delay_ms (100);  //   
_0x190:
	SBIS 0x13,0
	RJMP _0x191
	LDI  R26,LOW(100)
	LDI  R27,0
	RCALL _delay_ms
	RJMP _0x190
_0x191:
; 0000 041A PORTC.2 = 1;
	SBI  0x15,2
; 0000 041B                         _Err = 0;               //  
	LDI  R30,LOW(0)
	STS  __Err,R30
	STS  __Err+1,R30
; 0000 041C                         i=31;                   //   
	LDI  R30,LOW(31)
	LDI  R31,HIGH(31)
	STD  Y+2,R30
	STD  Y+2+1,R31
; 0000 041D                         _Blokir=0;
	LDI  R30,LOW(0)
	STS  __Blokir,R30
	STS  __Blokir+1,R30
; 0000 041E                         Zapusk();
	RCALL _Zapusk
; 0000 041F                         PORTC.2 = 0;
	CBI  0x15,2
; 0000 0420                         };
_0x18E:
; 0000 0421                     };
	LDD  R30,Y+2
	LDD  R31,Y+2+1
	ADIW R30,1
	STD  Y+2,R30
	STD  Y+2+1,R31
	RJMP _0x186
_0x187:
; 0000 0422                 };
	ADIW R28,4
_0x178:
; 0000 0423             };
_0x162:
; 0000 0424 
; 0000 0425         };
_0x14E:
; 0000 0426 
; 0000 0427     };
	ADIW R28,8
	RJMP _0x12F
; 0000 0428 }
_0x196:
	RJMP _0x196
; .FEND

	.CSEG
_ds18b20_select:
; .FSTART _ds18b20_select
	RCALL SUBOPT_0xD
	ST   -Y,R17
	RCALL _w1_init
	CPI  R30,0
	BRNE _0x2000003
	LDI  R30,LOW(0)
	RJMP _0x2020002
_0x2000003:
	LDD  R30,Y+1
	LDD  R31,Y+1+1
	SBIW R30,0
	BREQ _0x2000004
	LDI  R26,LOW(85)
	RCALL _w1_write
	LDI  R17,LOW(0)
_0x2000006:
	RCALL SUBOPT_0x48
	LD   R30,X+
	STD  Y+1,R26
	STD  Y+1+1,R27
	MOV  R26,R30
	RCALL _w1_write
	SUBI R17,-LOW(1)
	CPI  R17,8
	BRLO _0x2000006
	RJMP _0x2000008
_0x2000004:
	LDI  R26,LOW(204)
	RCALL _w1_write
_0x2000008:
	LDI  R30,LOW(1)
	RJMP _0x2020002
; .FEND
_ds18b20_read_spd:
; .FSTART _ds18b20_read_spd
	RCALL SUBOPT_0xD
	RCALL __SAVELOCR4
	LDD  R26,Y+4
	LDD  R27,Y+4+1
	RCALL SUBOPT_0x49
	BRNE _0x2000009
	LDI  R30,LOW(0)
	RJMP _0x2020003
_0x2000009:
	LDI  R26,LOW(190)
	RCALL _w1_write
	LDI  R17,LOW(0)
	__POINTWRM 18,19,___ds18b20_scratch_pad
_0x200000B:
	PUSH R19
	PUSH R18
	__ADDWRN 18,19,1
	RCALL _w1_read
	POP  R26
	POP  R27
	ST   X,R30
	SUBI R17,-LOW(1)
	CPI  R17,9
	BRLO _0x200000B
	LDI  R30,LOW(___ds18b20_scratch_pad)
	LDI  R31,HIGH(___ds18b20_scratch_pad)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R26,LOW(9)
	RCALL _w1_dow_crc8
	RCALL __LNEGB1
_0x2020003:
	RCALL __LOADLOCR4
_0x2020004:
	ADIW R28,6
	RET
; .FEND
_ds18b20_temperature:
; .FSTART _ds18b20_temperature
	RCALL SUBOPT_0xD
	ST   -Y,R17
	RCALL SUBOPT_0x48
	RCALL _ds18b20_read_spd
	CPI  R30,0
	BRNE _0x200000D
	RCALL SUBOPT_0x4A
	RJMP _0x2020002
_0x200000D:
	__GETB1MN ___ds18b20_scratch_pad,4
	SWAP R30
	ANDI R30,0xF
	LSR  R30
	ANDI R30,LOW(0x3)
	MOV  R17,R30
	RCALL SUBOPT_0x48
	RCALL SUBOPT_0x49
	BRNE _0x200000E
	RCALL SUBOPT_0x4A
	RJMP _0x2020002
_0x200000E:
	LDI  R26,LOW(68)
	RCALL _w1_write
	MOV  R30,R17
	LDI  R26,LOW(_conv_delay_G100*2)
	LDI  R27,HIGH(_conv_delay_G100*2)
	RCALL SUBOPT_0x4B
	RCALL __GETW2PF
	RCALL _delay_ms
	RCALL SUBOPT_0x48
	RCALL _ds18b20_read_spd
	CPI  R30,0
	BRNE _0x200000F
	RCALL SUBOPT_0x4A
	RJMP _0x2020002
_0x200000F:
	RCALL _w1_init
	MOV  R30,R17
	LDI  R26,LOW(_bit_mask_G100*2)
	LDI  R27,HIGH(_bit_mask_G100*2)
	RCALL SUBOPT_0x4B
	RCALL __GETW1PF
	LDS  R26,___ds18b20_scratch_pad
	LDS  R27,___ds18b20_scratch_pad+1
	AND  R30,R26
	AND  R31,R27
	RCALL __CWD1
	RCALL __CDF1
	__GETD2N 0x3D800000
	RCALL __MULF12
_0x2020002:
	LDD  R17,Y+0
	ADIW R28,3
	RET
; .FEND
_ds18b20_init:
; .FSTART _ds18b20_init
	ST   -Y,R26
	LDD  R26,Y+3
	LDD  R27,Y+3+1
	RCALL SUBOPT_0x49
	BRNE _0x2000010
	LDI  R30,LOW(0)
	RJMP _0x2020001
_0x2000010:
	LD   R30,Y
	SWAP R30
	ANDI R30,0xF0
	LSL  R30
	ORI  R30,LOW(0x1F)
	ST   Y,R30
	LDI  R26,LOW(78)
	RCALL _w1_write
	LDD  R26,Y+1
	RCALL _w1_write
	LDD  R26,Y+2
	RCALL _w1_write
	LD   R26,Y
	RCALL _w1_write
	LDD  R26,Y+3
	LDD  R27,Y+3+1
	RCALL _ds18b20_read_spd
	CPI  R30,0
	BRNE _0x2000011
	LDI  R30,LOW(0)
	RJMP _0x2020001
_0x2000011:
	__GETB2MN ___ds18b20_scratch_pad,3
	LDD  R30,Y+2
	CP   R30,R26
	BRNE _0x2000013
	__GETB2MN ___ds18b20_scratch_pad,2
	LDD  R30,Y+1
	CP   R30,R26
	BRNE _0x2000013
	__GETB2MN ___ds18b20_scratch_pad,4
	LD   R30,Y
	CP   R30,R26
	BREQ _0x2000012
_0x2000013:
	LDI  R30,LOW(0)
	RJMP _0x2020001
_0x2000012:
	LDD  R26,Y+3
	LDD  R27,Y+3+1
	RCALL SUBOPT_0x49
	BRNE _0x2000015
	LDI  R30,LOW(0)
	RJMP _0x2020001
_0x2000015:
	LDI  R26,LOW(72)
	RCALL _w1_write
	LDI  R26,LOW(15)
	RCALL SUBOPT_0x37
	RCALL _w1_init
_0x2020001:
	ADIW R28,5
	RET
; .FEND

	.DSEG
___ds18b20_scratch_pad:
	.BYTE 0x9
_temp1:
	.BYTE 0x4
_rom_code:
	.BYTE 0x12
_Bt:
	.BYTE 0x1
_Ct:
	.BYTE 0x1
_Dt:
	.BYTE 0x1
_znak:
	.BYTE 0x2
_Bt1:
	.BYTE 0x2
_i:
	.BYTE 0x1
_rx_cursor:
	.BYTE 0x1
_MyBuffer:
	.BYTE 0x96
_z:
	.BYTE 0x2
_cmd_8:
	.BYTE 0xD
__flag:
	.BYTE 0x2
_Temperat:
	.BYTE 0x2
__Err:
	.BYTE 0x2
__Err_out:
	.BYTE 0x2
__Blokir:
	.BYTE 0x2
__Tel:
	.BYTE 0x2
_Ring:
	.BYTE 0x2
_Deact:
	.BYTE 0x2
__Tel_SMS:
	.BYTE 0x1
__tim:
	.BYTE 0x2

	.ESEG
_cmd_8e:
	.DB  0x2B,0x37,0x39,0x31
	.DB  0x32,0x33,0x34,0x35
	.DB  0x36,0x37,0x38,0x39
	.DB  0x0
__Tel_SMS_E:
	.DB  0x0

	.CSEG
;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x0:
	ST   -Y,R26
	ST   -Y,R27
	ST   -Y,R30
	ST   -Y,R31
	IN   R30,SREG
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 29 TIMES, CODE SIZE REDUCTION:110 WORDS
SUBOPT_0x1:
	LD   R30,X+
	LD   R31,X+
	ADIW R30,1
	ST   -X,R31
	ST   -X,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x2:
	LD   R30,Y+
	OUT  SREG,R30
	LD   R31,Y+
	LD   R30,Y+
	LD   R27,Y+
	LD   R26,Y+
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 7 TIMES, CODE SIZE REDUCTION:16 WORDS
SUBOPT_0x3:
	LDS  R26,_Ring
	LDS  R27,_Ring+1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 21 TIMES, CODE SIZE REDUCTION:18 WORDS
SUBOPT_0x4:
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x5:
	LDI  R26,LOW(_Ring)
	LDI  R27,HIGH(_Ring)
	RJMP SUBOPT_0x1

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:18 WORDS
SUBOPT_0x6:
	LDI  R30,LOW(0)
	STS  _Ring,R30
	STS  _Ring+1,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:10 WORDS
SUBOPT_0x7:
	LDS  R26,_Deact
	LDS  R27,_Deact+1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x8:
	LDI  R26,LOW(_Deact)
	LDI  R27,HIGH(_Deact)
	RJMP SUBOPT_0x1

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:10 WORDS
SUBOPT_0x9:
	LDI  R30,LOW(0)
	STS  _Deact,R30
	STS  _Deact+1,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0xA:
	LDI  R31,0
	SUBI R30,LOW(-_MyBuffer)
	SBCI R31,HIGH(-_MyBuffer)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0xB:
	STS  _i,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0xC:
	RCALL SUBOPT_0x4
	STS  _Temperat,R30
	STS  _Temperat+1,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0xD:
	ST   -Y,R27
	ST   -Y,R26
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0xE:
	LDS  R26,_znak
	LDS  R27,_znak+1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0xF:
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 14 TIMES, CODE SIZE REDUCTION:24 WORDS
SUBOPT_0x10:
	LDI  R26,LOW(500)
	LDI  R27,HIGH(500)
	RJMP _delay_ms

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:12 WORDS
SUBOPT_0x11:
	STS  _temp1,R30
	STS  _temp1+1,R31
	STS  _temp1+2,R22
	STS  _temp1+3,R23
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:26 WORDS
SUBOPT_0x12:
	LDS  R26,_temp1
	LDS  R27,_temp1+1
	LDS  R24,_temp1+2
	LDS  R25,_temp1+3
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x13:
	LDS  R30,_temp1
	LDS  R31,_temp1+1
	LDS  R22,_temp1+2
	LDS  R23,_temp1+3
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x14:
	LDI  R30,LOW(0)
	STS  _rx_cursor,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:6 WORDS
SUBOPT_0x15:
	LDI  R26,LOW(1000)
	LDI  R27,HIGH(1000)
	RJMP _delay_ms

;OPTIMIZER ADDED SUBROUTINE, CALLED 7 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x16:
	SUBI R30,LOW(-_cmd_8)
	SBCI R31,HIGH(-_cmd_8)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 7 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x17:
	LDS  R30,_rx_cursor
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x18:
	RCALL SUBOPT_0x17
	SUBI R30,-LOW(1)
	STS  _rx_cursor,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 20 TIMES, CODE SIZE REDUCTION:74 WORDS
SUBOPT_0x19:
	LDI  R30,LOW(0)
	STS  _z,R30
	STS  _z+1,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x1A:
	LDS  R30,_z
	LDS  R31,_z+1
	SUBI R30,LOW(-_cmd_4*2)
	SBCI R31,HIGH(-_cmd_4*2)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 17 TIMES, CODE SIZE REDUCTION:14 WORDS
SUBOPT_0x1B:
	LPM  R30,Z
	CPI  R30,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 17 TIMES, CODE SIZE REDUCTION:62 WORDS
SUBOPT_0x1C:
	LPM  R0,Z
	OUT  0xC,R0
	LDI  R26,LOW(100)
	LDI  R27,0
	RJMP _delay_ms

;OPTIMIZER ADDED SUBROUTINE, CALLED 20 TIMES, CODE SIZE REDUCTION:36 WORDS
SUBOPT_0x1D:
	LDI  R26,LOW(_z)
	LDI  R27,HIGH(_z)
	RJMP SUBOPT_0x1

;OPTIMIZER ADDED SUBROUTINE, CALLED 11 TIMES, CODE SIZE REDUCTION:8 WORDS
SUBOPT_0x1E:
	LDI  R30,LOW(13)
	OUT  0xC,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x1F:
	__GETWRN 16,17,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x20:
	SBI  0x15,1
	LDI  R26,LOW(100)
	LDI  R27,0
	RJMP _delay_ms

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x21:
	SBI  0x15,2
	LDI  R26,LOW(100)
	LDI  R27,0
	RJMP _delay_ms

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x22:
	SBI  0x15,3
	LDI  R26,LOW(100)
	LDI  R27,0
	RJMP _delay_ms

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x23:
	CBI  0x15,1
	LDI  R26,LOW(100)
	LDI  R27,0
	RJMP _delay_ms

;OPTIMIZER ADDED SUBROUTINE, CALLED 16 TIMES, CODE SIZE REDUCTION:28 WORDS
SUBOPT_0x24:
	LDI  R26,LOW(100)
	LDI  R27,0
	RJMP _delay_ms

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x25:
	__ADDWRN 16,17,1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:23 WORDS
SUBOPT_0x26:
	LDS  R30,_z
	LDS  R31,_z+1
	SUBI R30,LOW(-_cmd_1*2)
	SBCI R31,HIGH(-_cmd_1*2)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x27:
	LDS  R30,_z
	LDS  R31,_z+1
	SUBI R30,LOW(-_cmd_0*2)
	SBCI R31,HIGH(-_cmd_0*2)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x28:
	LDS  R30,_z
	LDS  R31,_z+1
	SUBI R30,LOW(-_cmd_9*2)
	SBCI R31,HIGH(-_cmd_9*2)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x29:
	LDS  R30,_z
	LDS  R31,_z+1
	SUBI R30,LOW(-_cmd_2*2)
	SBCI R31,HIGH(-_cmd_2*2)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x2A:
	LDS  R30,_z
	LDS  R31,_z+1
	SUBI R30,LOW(-_cmd_3*2)
	SBCI R31,HIGH(-_cmd_3*2)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x2B:
	LDI  R30,LOW(34)
	OUT  0xC,R30
	RJMP SUBOPT_0x24

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:13 WORDS
SUBOPT_0x2C:
	LDS  R30,_z
	LDS  R31,_z+1
	RCALL SUBOPT_0x16
	LD   R30,Z
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 8 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x2D:
	OUT  0xC,R30
	RJMP SUBOPT_0x24

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x2E:
	LDS  R30,_z
	LDS  R31,_z+1
	SUBI R30,LOW(-_cmd_5*2)
	SBCI R31,HIGH(-_cmd_5*2)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 7 TIMES, CODE SIZE REDUCTION:16 WORDS
SUBOPT_0x2F:
	LDS  R26,__flag
	LDS  R27,__flag+1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x30:
	LDS  R30,_z
	LDS  R31,_z+1
	SUBI R30,LOW(-_cmd_6*2)
	SBCI R31,HIGH(-_cmd_6*2)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x31:
	LDS  R30,_z
	LDS  R31,_z+1
	SUBI R30,LOW(-_cmd_7*2)
	SBCI R31,HIGH(-_cmd_7*2)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x32:
	LDS  R30,_z
	LDS  R31,_z+1
	SUBI R30,LOW(-_cmd_11*2)
	SBCI R31,HIGH(-_cmd_11*2)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x33:
	LDS  R30,_z
	LDS  R31,_z+1
	SUBI R30,LOW(-_cmd_12*2)
	SBCI R31,HIGH(-_cmd_12*2)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x34:
	LDS  R30,_z
	LDS  R31,_z+1
	SUBI R30,LOW(-_cmd_14*2)
	SBCI R31,HIGH(-_cmd_14*2)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:13 WORDS
SUBOPT_0x35:
	LDS  R30,_z
	LDS  R31,_z+1
	SUBI R30,LOW(-_cmd_2_*2)
	SBCI R31,HIGH(-_cmd_2_*2)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x36:
	LDS  R30,_z
	LDS  R31,_z+1
	SUBI R30,LOW(-_cmd_10*2)
	SBCI R31,HIGH(-_cmd_10*2)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x37:
	LDI  R27,0
	RJMP _delay_ms

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:10 WORDS
SUBOPT_0x38:
	__GETWRN 16,17,3000
	RCALL SUBOPT_0x4
	STS  __Err_out,R30
	STS  __Err_out+1,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x39:
	RCALL SUBOPT_0x4
	STS  __Blokir,R30
	STS  __Blokir+1,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:6 WORDS
SUBOPT_0x3A:
	LDI  R30,LOW(0)
	STS  __Err_out,R30
	STS  __Err_out+1,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:14 WORDS
SUBOPT_0x3B:
	LDS  R26,__Err
	LDS  R27,__Err+1
	SBIW R26,2
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x3C:
	__GETWRN 18,19,30
	RCALL SUBOPT_0x4
	STS  __Err_out,R30
	STS  __Err_out+1,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x3D:
	LDS  R26,__Err_out
	LDS  R27,__Err_out+1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:16 WORDS
SUBOPT_0x3E:
	__GETWRN 16,17,-15536
	RCALL SUBOPT_0x4
	STS  __Err_out,R30
	STS  __Err_out+1,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x3F:
	CBI  0x18,1
	CBI  0x18,0
	__GETWRN 16,17,-15536
	LDI  R30,LOW(410)
	LDI  R31,HIGH(410)
	ST   Y,R30
	STD  Y+1,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x40:
	LDI  R30,LOW(410)
	LDI  R31,HIGH(410)
	ST   Y,R30
	STD  Y+1,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:10 WORDS
SUBOPT_0x41:
	__GETWRN 18,19,70
	RCALL SUBOPT_0x4
	STS  __Err_out,R30
	STS  __Err_out+1,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:8 WORDS
SUBOPT_0x42:
	RCALL _AON_
	STS  __Tel,R30
	STS  __Tel+1,R31
	RCALL _Otboy
	LDS  R26,__Tel
	LDS  R27,__Tel+1
	SBIW R26,1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x43:
	LDI  R30,LOW(0)
	STS  __Err,R30
	STS  __Err+1,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x44:
	LDI  R30,LOW(0)
	STS  _Temperat,R30
	STS  _Temperat+1,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x45:
	STS  __flag,R30
	STS  __flag+1,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0x46:
	LDS  R26,_z
	LDS  R27,_z+1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:6 WORDS
SUBOPT_0x47:
	LDS  R30,_z
	LDS  R31,_z+1
	RCALL SUBOPT_0x16
	MOVW R0,R30
	RCALL SUBOPT_0x46
	SUBI R26,LOW(-_cmd_8e)
	SBCI R27,HIGH(-_cmd_8e)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x48:
	LDD  R26,Y+1
	LDD  R27,Y+1+1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x49:
	RCALL _ds18b20_select
	CPI  R30,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x4A:
	__GETD1N 0xC61C3C00
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x4B:
	LDI  R31,0
	LSL  R30
	ROL  R31
	ADD  R30,R26
	ADC  R31,R27
	RET


	.CSEG
_delay_ms:
	adiw r26,0
	breq __delay_ms1
__delay_ms0:
	__DELAY_USW 0x3E8
	wdr
	sbiw r26,1
	brne __delay_ms0
__delay_ms1:
	ret

_w1_init:
	clr  r30
	cbi  __w1_port,__w1_bit
	sbi  __w1_port-1,__w1_bit
	__DELAY_USW 0x1E0
	cbi  __w1_port-1,__w1_bit
	__DELAY_USB 0x13
	sbis __w1_port-2,__w1_bit
	ret
	__DELAY_USB 0x65
	sbis __w1_port-2,__w1_bit
	ldi  r30,1
	__DELAY_USW 0x186
	ret

__w1_read_bit:
	sbi  __w1_port-1,__w1_bit
	__DELAY_USB 0x3
	cbi  __w1_port-1,__w1_bit
	__DELAY_USB 0xF
	clc
	sbic __w1_port-2,__w1_bit
	sec
	ror  r30
	__DELAY_USB 0x6B
	ret

__w1_write_bit:
	clt
	sbi  __w1_port-1,__w1_bit
	__DELAY_USB 0x3
	sbrc r23,0
	cbi  __w1_port-1,__w1_bit
	__DELAY_USB 0x11
	sbic __w1_port-2,__w1_bit
	rjmp __w1_write_bit0
	sbrs r23,0
	rjmp __w1_write_bit1
	ret
__w1_write_bit0:
	sbrs r23,0
	ret
__w1_write_bit1:
	__DELAY_USB 0x64
	cbi  __w1_port-1,__w1_bit
	__DELAY_USB 0x7
	set
	ret

_w1_read:
	ldi  r22,8
	__w1_read0:
	rcall __w1_read_bit
	dec  r22
	brne __w1_read0
	ret

_w1_write:
	mov  r23,r26
	ldi  r22,8
	clr  r30
__w1_write0:
	rcall __w1_write_bit
	brtc __w1_write1
	ror  r23
	dec  r22
	brne __w1_write0
	inc  r30
__w1_write1:
	ret

_w1_search:
	push r20
	push r21
	clr  r1
	clr  r20
__w1_search0:
	mov  r0,r1
	clr  r1
	rcall _w1_init
	tst  r30
	breq __w1_search7
	push r26
	ld   r26,y
	rcall _w1_write
	pop  r26
	ldi  r21,1
__w1_search1:
	cp   r21,r0
	brsh __w1_search6
	rcall __w1_read_bit
	sbrc r30,7
	rjmp __w1_search2
	rcall __w1_read_bit
	sbrc r30,7
	rjmp __w1_search3
	rcall __sel_bit
	and  r24,r25
	brne __w1_search3
	mov  r1,r21
	rjmp __w1_search3
__w1_search2:
	rcall __w1_read_bit
__w1_search3:
	rcall __sel_bit
	and  r24,r25
	ldi  r23,0
	breq __w1_search5
__w1_search4:
	ldi  r23,1
__w1_search5:
	rcall __w1_write_bit
	rjmp __w1_search13
__w1_search6:
	rcall __w1_read_bit
	sbrs r30,7
	rjmp __w1_search9
	rcall __w1_read_bit
	sbrs r30,7
	rjmp __w1_search8
__w1_search7:
	mov  r30,r20
	pop  r21
	pop  r20
	adiw r28,1
	ret
__w1_search8:
	set
	rcall __set_bit
	rjmp __w1_search4
__w1_search9:
	rcall __w1_read_bit
	sbrs r30,7
	rjmp __w1_search10
	rjmp __w1_search11
__w1_search10:
	cp   r21,r0
	breq __w1_search12
	mov  r1,r21
__w1_search11:
	clt
	rcall __set_bit
	clr  r23
	rcall __w1_write_bit
	rjmp __w1_search13
__w1_search12:
	set
	rcall __set_bit
	ldi  r23,1
	rcall __w1_write_bit
__w1_search13:
	inc  r21
	cpi  r21,65
	brlt __w1_search1
	rcall __w1_read_bit
	rol  r30
	rol  r30
	andi r30,1
	adiw r26,8
	st   x,r30
	sbiw r26,8
	inc  r20
	tst  r1
	breq __w1_search7
	ldi  r21,9
__w1_search14:
	ld   r30,x
	adiw r26,9
	st   x,r30
	sbiw r26,8
	dec  r21
	brne __w1_search14
	rjmp __w1_search0

__sel_bit:
	mov  r30,r21
	dec  r30
	mov  r22,r30
	lsr  r30
	lsr  r30
	lsr  r30
	clr  r31
	add  r30,r26
	adc  r31,r27
	ld   r24,z
	ldi  r25,1
	andi r22,7
__sel_bit0:
	breq __sel_bit1
	lsl  r25
	dec  r22
	rjmp __sel_bit0
__sel_bit1:
	ret

__set_bit:
	rcall __sel_bit
	brts __set_bit2
	com  r25
	and  r24,r25
	rjmp __set_bit3
__set_bit2:
	or   r24,r25
__set_bit3:
	st   z,r24
	ret

_w1_dow_crc8:
	clr  r30
	tst  r26
	breq __w1_dow_crc83
	mov  r24,r26
	ldi  r22,0x18
	ld   r26,y
	ldd  r27,y+1
__w1_dow_crc80:
	ldi  r25,8
	ld   r31,x+
__w1_dow_crc81:
	mov  r23,r31
	eor  r23,r30
	ror  r23
	brcc __w1_dow_crc82
	eor  r30,r22
__w1_dow_crc82:
	ror  r30
	lsr  r31
	dec  r25
	brne __w1_dow_crc81
	dec  r24
	brne __w1_dow_crc80
__w1_dow_crc83:
	adiw r28,2
	ret

__ANEGF1:
	SBIW R30,0
	SBCI R22,0
	SBCI R23,0
	BREQ __ANEGF10
	SUBI R23,0x80
__ANEGF10:
	RET

__ROUND_REPACK:
	TST  R21
	BRPL __REPACK
	CPI  R21,0x80
	BRNE __ROUND_REPACK0
	SBRS R30,0
	RJMP __REPACK
__ROUND_REPACK0:
	ADIW R30,1
	ADC  R22,R25
	ADC  R23,R25
	BRVS __REPACK1

__REPACK:
	LDI  R21,0x80
	EOR  R21,R23
	BRNE __REPACK0
	PUSH R21
	RJMP __ZERORES
__REPACK0:
	CPI  R21,0xFF
	BREQ __REPACK1
	LSL  R22
	LSL  R0
	ROR  R21
	ROR  R22
	MOV  R23,R21
	RET
__REPACK1:
	PUSH R21
	TST  R0
	BRMI __REPACK2
	RJMP __MAXRES
__REPACK2:
	RJMP __MINRES

__UNPACK:
	LDI  R21,0x80
	MOV  R1,R25
	AND  R1,R21
	LSL  R24
	ROL  R25
	EOR  R25,R21
	LSL  R21
	ROR  R24

__UNPACK1:
	LDI  R21,0x80
	MOV  R0,R23
	AND  R0,R21
	LSL  R22
	ROL  R23
	EOR  R23,R21
	LSL  R21
	ROR  R22
	RET

__CFD1U:
	SET
	RJMP __CFD1U0
__CFD1:
	CLT
__CFD1U0:
	PUSH R21
	RCALL __UNPACK1
	CPI  R23,0x80
	BRLO __CFD10
	CPI  R23,0xFF
	BRCC __CFD10
	RJMP __ZERORES
__CFD10:
	LDI  R21,22
	SUB  R21,R23
	BRPL __CFD11
	NEG  R21
	CPI  R21,8
	BRTC __CFD19
	CPI  R21,9
__CFD19:
	BRLO __CFD17
	SER  R30
	SER  R31
	SER  R22
	LDI  R23,0x7F
	BLD  R23,7
	RJMP __CFD15
__CFD17:
	CLR  R23
	TST  R21
	BREQ __CFD15
__CFD18:
	LSL  R30
	ROL  R31
	ROL  R22
	ROL  R23
	DEC  R21
	BRNE __CFD18
	RJMP __CFD15
__CFD11:
	CLR  R23
__CFD12:
	CPI  R21,8
	BRLO __CFD13
	MOV  R30,R31
	MOV  R31,R22
	MOV  R22,R23
	SUBI R21,8
	RJMP __CFD12
__CFD13:
	TST  R21
	BREQ __CFD15
__CFD14:
	LSR  R23
	ROR  R22
	ROR  R31
	ROR  R30
	DEC  R21
	BRNE __CFD14
__CFD15:
	TST  R0
	BRPL __CFD16
	RCALL __ANEGD1
__CFD16:
	POP  R21
	RET

__CDF1U:
	SET
	RJMP __CDF1U0
__CDF1:
	CLT
__CDF1U0:
	SBIW R30,0
	SBCI R22,0
	SBCI R23,0
	BREQ __CDF10
	CLR  R0
	BRTS __CDF11
	TST  R23
	BRPL __CDF11
	COM  R0
	RCALL __ANEGD1
__CDF11:
	MOV  R1,R23
	LDI  R23,30
	TST  R1
__CDF12:
	BRMI __CDF13
	DEC  R23
	LSL  R30
	ROL  R31
	ROL  R22
	ROL  R1
	RJMP __CDF12
__CDF13:
	MOV  R30,R31
	MOV  R31,R22
	MOV  R22,R1
	PUSH R21
	RCALL __REPACK
	POP  R21
__CDF10:
	RET

__ZERORES:
	CLR  R30
	CLR  R31
	CLR  R22
	CLR  R23
	POP  R21
	RET

__MINRES:
	SER  R30
	SER  R31
	LDI  R22,0x7F
	SER  R23
	POP  R21
	RET

__MAXRES:
	SER  R30
	SER  R31
	LDI  R22,0x7F
	LDI  R23,0x7F
	POP  R21
	RET

__MULF12:
	PUSH R21
	RCALL __UNPACK
	CPI  R23,0x80
	BREQ __ZERORES
	CPI  R25,0x80
	BREQ __ZERORES
	EOR  R0,R1
	SEC
	ADC  R23,R25
	BRVC __MULF124
	BRLT __ZERORES
__MULF125:
	TST  R0
	BRMI __MINRES
	RJMP __MAXRES
__MULF124:
	PUSH R0
	PUSH R17
	PUSH R18
	PUSH R19
	PUSH R20
	CLR  R17
	CLR  R18
	CLR  R25
	MUL  R22,R24
	MOVW R20,R0
	MUL  R24,R31
	MOV  R19,R0
	ADD  R20,R1
	ADC  R21,R25
	MUL  R22,R27
	ADD  R19,R0
	ADC  R20,R1
	ADC  R21,R25
	MUL  R24,R30
	RCALL __MULF126
	MUL  R27,R31
	RCALL __MULF126
	MUL  R22,R26
	RCALL __MULF126
	MUL  R27,R30
	RCALL __MULF127
	MUL  R26,R31
	RCALL __MULF127
	MUL  R26,R30
	ADD  R17,R1
	ADC  R18,R25
	ADC  R19,R25
	ADC  R20,R25
	ADC  R21,R25
	MOV  R30,R19
	MOV  R31,R20
	MOV  R22,R21
	MOV  R21,R18
	POP  R20
	POP  R19
	POP  R18
	POP  R17
	POP  R0
	TST  R22
	BRMI __MULF122
	LSL  R21
	ROL  R30
	ROL  R31
	ROL  R22
	RJMP __MULF123
__MULF122:
	INC  R23
	BRVS __MULF125
__MULF123:
	RCALL __ROUND_REPACK
	POP  R21
	RET

__MULF127:
	ADD  R17,R0
	ADC  R18,R1
	ADC  R19,R25
	RJMP __MULF128
__MULF126:
	ADD  R18,R0
	ADC  R19,R1
__MULF128:
	ADC  R20,R25
	ADC  R21,R25
	RET

__CMPF12:
	TST  R25
	BRMI __CMPF120
	TST  R23
	BRMI __CMPF121
	CP   R25,R23
	BRLO __CMPF122
	BRNE __CMPF121
	CP   R26,R30
	CPC  R27,R31
	CPC  R24,R22
	BRLO __CMPF122
	BREQ __CMPF123
__CMPF121:
	CLZ
	CLC
	RET
__CMPF122:
	CLZ
	SEC
	RET
__CMPF123:
	SEZ
	CLC
	RET
__CMPF120:
	TST  R23
	BRPL __CMPF122
	CP   R25,R23
	BRLO __CMPF121
	BRNE __CMPF122
	CP   R30,R26
	CPC  R31,R27
	CPC  R22,R24
	BRLO __CMPF122
	BREQ __CMPF123
	RJMP __CMPF121

__LTF12:
	RCALL __CMPF12
	LDI  R30,1
	BREQ __LTF120
	BRCS __LTF121
__LTF120:
	CLR  R30
__LTF121:
	RET

__GTF12:
	RCALL __CMPF12
	LDI  R30,1
	BREQ __GTF120
	BRCC __GTF121
__GTF120:
	CLR  R30
__GTF121:
	RET

__ANEGD1:
	COM  R31
	COM  R22
	COM  R23
	NEG  R30
	SBCI R31,-1
	SBCI R22,-1
	SBCI R23,-1
	RET

__CWD1:
	MOV  R22,R31
	ADD  R22,R22
	SBC  R22,R22
	MOV  R23,R22
	RET

__EQB12:
	CP   R30,R26
	LDI  R30,1
	BREQ __EQB12T
	CLR  R30
__EQB12T:
	RET

__NEB12:
	CP   R30,R26
	LDI  R30,1
	BRNE __NEB12T
	CLR  R30
__NEB12T:
	RET

__LTW12:
	CP   R26,R30
	CPC  R27,R31
	LDI  R30,1
	BRLT __LTW12T
	CLR  R30
__LTW12T:
	RET

__LNEGB1:
	TST  R30
	LDI  R30,1
	BREQ __LNEGB1F
	CLR  R30
__LNEGB1F:
	RET

__DIVW21U:
	CLR  R0
	CLR  R1
	LDI  R25,16
__DIVW21U1:
	LSL  R26
	ROL  R27
	ROL  R0
	ROL  R1
	SUB  R0,R30
	SBC  R1,R31
	BRCC __DIVW21U2
	ADD  R0,R30
	ADC  R1,R31
	RJMP __DIVW21U3
__DIVW21U2:
	SBR  R26,1
__DIVW21U3:
	DEC  R25
	BRNE __DIVW21U1
	MOVW R30,R26
	MOVW R26,R0
	RET

__MODW21U:
	RCALL __DIVW21U
	MOVW R30,R26
	RET

__GETW1PF:
	LPM  R0,Z+
	LPM  R31,Z
	MOV  R30,R0
	RET

__GETW2PF:
	LPM  R26,Z+
	LPM  R27,Z
	RET

__EEPROMRDB:
	SBIC EECR,EEWE
	RJMP __EEPROMRDB
	PUSH R31
	IN   R31,SREG
	CLI
	OUT  EEARL,R26
	OUT  EEARH,R27
	SBI  EECR,EERE
	IN   R30,EEDR
	OUT  SREG,R31
	POP  R31
	RET

__EEPROMWRB:
	SBIS EECR,EEWE
	RJMP __EEPROMWRB1
	WDR
	RJMP __EEPROMWRB
__EEPROMWRB1:
	IN   R25,SREG
	CLI
	OUT  EEARL,R26
	OUT  EEARH,R27
	SBI  EECR,EERE
	IN   R24,EEDR
	CP   R30,R24
	BREQ __EEPROMWRB0
	OUT  EEDR,R30
	SBI  EECR,EEMWE
	SBI  EECR,EEWE
__EEPROMWRB0:
	OUT  SREG,R25
	RET

__CPW02:
	CLR  R0
	CP   R0,R26
	CPC  R0,R27
	RET

__CPD02:
	CLR  R0
	CP   R0,R26
	CPC  R0,R27
	CPC  R0,R24
	CPC  R0,R25
	RET

__SAVELOCR6:
	ST   -Y,R21
__SAVELOCR5:
	ST   -Y,R20
__SAVELOCR4:
	ST   -Y,R19
__SAVELOCR3:
	ST   -Y,R18
__SAVELOCR2:
	ST   -Y,R17
	ST   -Y,R16
	RET

__LOADLOCR6:
	LDD  R21,Y+5
__LOADLOCR5:
	LDD  R20,Y+4
__LOADLOCR4:
	LDD  R19,Y+3
__LOADLOCR3:
	LDD  R18,Y+2
__LOADLOCR2:
	LDD  R17,Y+1
	LD   R16,Y
	RET

;END OF CODE MARKER
__END_OF_CODE:
